#!/usr/bin/python3
#!/usr/bin/python3
# -*- coding: utf-8 -*-

import sys
# python3 default code is 'utf-8'
# from importlib import reload
#
# reload(sys)
# sys.
# sys.defaultencoding('utf8')

import os
import dbus
import dbus.service
import traceback
import re
import math
from PyQt5.QtGui import *
from PyQt5.QtCore import *
from PyQt5.QtWidgets import QApplication, QMessageBox, QListWidgetItem

from service.dbus_service import DbusService
from service.kylin_update_service import KylinUpdateService
from utils.enums import LaunchMode, TaskMode, LWMode, AUPSource, AppType, AppMsg, Signals, LOADINGWIDTH, LOADINGHEIGHT, \
    MAINWIDTH, MAINHEIGHT, DETAILWIDTH, DETAILHEIGHT, SINTERFACE, SINTERFACES, RUNLIST, SPHEIGHT, SPWIDTH
from utils.common_utils import CommonUtils
from utils.util_dbus import UtilDbus
from utils.log_manager import LogManager
from utils.down_load_deb import  *
from utils import log_manager
from mainui.updatelistitemwidget import UpdateListItemWidget
from mainui.messagewidget import MessageWidget
from mainui.loadingwidget import LoadingWidget
from mainui.topwidget import TopWidget
from mainui.bottomwidget import BottomWidget
from mainui.detailwidget import DetailWidget
from mainui.system_tray import SystemTray
from mainui.confwidget import ConfigWidget
from mainui.menubar import Menubar
from mainui.downloadwidget import *
from mainui.update_success_widget import *
from mainui.titlebar import *
from mainui.appdetails import *
from utils.db_install_information import  *
from model.upackage import UPackage

import urllib
import urllib.request
import urllib.error
import urllib3
import urllib3.request
import urllib.parse
import socket
import time
import uuid
import threading
import datetime
import locale
import gettext
import fcntl
import platform
from concurrent.futures import ThreadPoolExecutor,wait
from multiprocessing import Pool
from subprocess import check_output
import subprocess

locale.setlocale(locale.LC_ALL, "")
gettext.bindtextdomain("kylin-update-manager", "/usr/share/locale")
gettext.textdomain("kylin-update-manager")
_ = gettext.gettext

PINGBACK_URL = "http://archive.kylinos-intranet.cn/kylin-update-manager-server/main.php?"
PKGLIST = []

# 类：用于进行main_work，由于进行外网源配置时时间太长到时线程任然会阻塞界面
class Thread_work(QThread):
    def __init__(self, parent=None):
        QThread.__init__(self)
        self.parent = parent

    def run(self):
        self.parent.main_work()


class Thread_check_update(QThread):
    def __init__(self, parent=None):
        QThread.__init__(self)
        self.parent = parent

    def run(self):
        self.parent.kus.start_access()

class Thread_get_changelog(QThread):
    exit_app = pyqtSignal()
    def __init__(self,parent=None):
        QThread.__init__(self)
        self.parent = parent
        self.app_list= []
        self.statue_list = []
        self.statue = ""
        self.str = str

    def get_variable(self,app_list,statue,str,statue_list=[]):
        self.app_list = self.app_list+app_list
        self.statue_list = self.statue_list +statue_list
        self.statue = statue
        self.str = str

    def run(self):
        num = 0
        for i in self.app_list:
            s = self.statue_list[num]
            self.parent.get_app_changelog(i,s)
            num = num+1
        if (self.statue == "success"):
            if(len(self.app_list) == 0):
                self.parent.pingback("", "", _("information acquisition"))
                if(self.parent.click_cancel_btn == True):
                    self.exit_app.emit()
                    #self.parent.exit_app_and_dbus()
                else:
                    self.parent.signal_show_exit.emit(_("No installation, exit the software"))
            else:
                if(len(self.parent.install_fail_list) == 0):
                    if (self.app_list[0]["name"] == "kylin-update-manager"):
                        # self.parent.kylin_update_manager_upgrade_finish()
                        pass
                    else:
                        if (self.parent.click_cancel_btn == True):
                            self.exit_app.emit()
                            #self.parent.exit_app_and_dbus()
                        else:
                            self.parent.update_seccuss("success")
                else:
                    if (self.parent.click_cancel_btn == True):
                        self.exit_app.emit()
                        #self.parent.exit_app_and_dbus()
                    else:
                        self.parent.update_seccuss("fail")
        else:
            if (self.parent.click_cancel_btn == True):
                self.exit_app.emit()
                #self.parent.exit_app_and_dbus()
            else:
                print(self.str)
                self.parent.set_default_sourceslist()
                self.parent.signal_show_exit.emit(self.str)


pool = ThreadPoolExecutor(max_workers=7)

class MainWindow(QWidget):
    service_key = ""
    hash_pwd = ""
    item_map_ordinary = {}
    item_map_important = {}
    item_map = {}
    item_num = 0
    get_app_num = 0
    update_item_map = {}

    size_ordinary = 0
    size_important = 0
    app_num_ordinary = 0
    app_num_important = 0
    selected_num_ordinary = 0
    selected_num_important = 0

    available_source = AUPSource.NOSOURCE
    is_log_init = False
    is_working = False
    is_working_c = False
    is_working_install = False
    will_install = False
    pkg_download_finish = False
    copy_one_finish = False
    puase = False
    is_error = False
    is_conffile = False
    launch_mode = None
    task_mode = None
    is_sp_update = False
    is_created = False
    is_down_puase = False

    click_config = False
    click_cancel = False
    click_cancel_btn = False

    menu_init = False

    iface = None
    kus = None
    cu = None

    puase_down_list = []
    Wait_install_list = []
    App_Version_list = []
    app_install_statue_list = []
    App_install_num = 0
    install_app_num = 0

    previous_process_type = ""
    work_list = []
    crucial_list = []
    c_work_list = []
    install_fail_list = []
    all_deb_pkg = []
    all_download_size = 0

    get_pos = pyqtSignal()
    signal_show_exit = pyqtSignal(str)
    change_loading_tiplabel = pyqtSignal(str, bool)
    kum_update_finish = pyqtSignal()
    clean_sp_widget = pyqtSignal()
    get_down_progress = pyqtSignal(str,str,str)
    down_deb_finish = pyqtSignal(str)
    installed_deb_finish = pyqtSignal()

    down_num = 0
    down_done = 0

    install_num = 0
    install_stop = 0
    installed_app_num = 0

    down_item = None
    install_item = None

    timer = QTimer()
    sp_timer = QTimer()
    exit_time = QTimer()
    again_time = QTimer()
    kum_time = QTimer()
    description = ""
    downloading_appname = ""

    firsttime_click_item = True

    def __init__(self, launch_mode, parent=None):
        QWidget.__init__(self, parent)

        # 设置全局异常处理函数
        sys.excepthook = self.global_except_hook
        self.launch_mode = launch_mode
        self.init_log()
        self.init_ui()
        #self.check_singleton()
        self.cu = CommonUtils()
        self.check_service_key()
        self.iface = DbusService()
        self.db_insert_thread = Thread_get_changelog(self)
        self.kus = KylinUpdateService(self)
        self.init_main_animation()
        self.init_connect()
        self.get_deb_pkg = Getfile()
        # self.pre_work()

    #
    # 函数：全局异常捕获
    # etype：异常类型
    # value：异常值
    # trace：堆栈信息
    #
    def global_except_hook(self, etype, value, trace):
        msg = traceback.format_exception(etype, value, trace)
        if self.is_log_init == True:
            LogManager.CRI("".join(msg))

        sys.__excepthook__(etype, value, trace)
        # self.exit_app("程序异常退出！详情见 $HOME/.cache/kum.log")
        self.exit_app(_("Crashed! For details in $HOME/.cache/kum.log"))

    #
    # 函数：初始化UI
    #
    def init_ui(self):
        self.setWindowIcon(QIcon("./res/kylin-update-manager.png"))
        self.setWindowTitle(_("Kylin Update Manager"))
        self.setWindowOpacity(1)
        self.setFocusPolicy(Qt.NoFocus)
        self.resize(LOADINGWIDTH, LOADINGHEIGHT)
        '''
        # 实例阴影shadow
        shadow = QGraphicsDropShadowEffect(self)
        # 设置阴影距离
        shadow.setOffset(0, 0)
        # 设置阴影颜色
        shadow.setColor(QColor("#888888"))
        # 设置阴影圆角
        shadow.setBlurRadius(6)
        # 给嵌套QWidget设置阴影
        self.widget.setGraphicsEffect(shadow)
        # 给垂直布局器设置边距(此步很重要, 设置宽度为阴影的宽度)
        '''
        self.setAutoFillBackground(True)
        # self.setAttribute(Qt.WA_TranslucentBackground)
        self.setWindowFlags(Qt.FramelessWindowHint | Qt.Widget)
        # self.setAttribute(Qt.WA_TranslucentBackground)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(255, 255, 255))  # eaf0f3
        self.setPalette(palette)
        # self.title_widget =  TitleBar(self.width(),True,True, _("Kylin Update Manager"),self)
        self.bottom_widget = BottomWidget(False, self)
        self.bottom_widget.hide()
        self.update_bottom_widget = BottomWidget(True, self)
        self.update_bottom_widget.setGeometry(0, 60, self.update_bottom_widget.width(),
                                              self.update_bottom_widget.height())
        self.update_bottom_widget.hide()
        self.detail_widget = DetailWidget(self)
        self.detail_widget.hide()
        self.titlebar = TitleBar(self.width(), True, True, _("Kylin Update Manager") + VERSION, self)

        self.titlebar.setGeometry(0, 0, self.titlebar.width(), self.titlebar.height())
        self.titlebar.show()
        self.loading_widget = LoadingWidget(self)
        self.loading_widget.setGeometry(0, 40, 550, 280)
        # self.quit_widget = LoadingWidget(self)
        # self.loading_widget.setStyleSheet("QWidget{border-radius:6px;border:1px solid #cfcfcf;}")

        self.update_succuss_widget = UpdateSuccessWidget(self)
        self.update_succuss_widget.hide()
        self.tipwidget = UpdateSuccessWidget(self)
        self.tipwidget.close_btn.clicked.connect(self.tipwidget_hide)
        self.mouse_press = False
        # self.animation_msg_box = MessageWidget("发现需要更新的软件。", False)
        self.animation_msg_box = MessageWidget(_("Updated software is available for this computer."), False)
        self.resize(0, 0)
        self.move_to_center()
        self.show()

        if (self.launch_mode == LaunchMode.MANUAL):
            self.resize(LOADINGWIDTH, LOADINGHEIGHT)
            self.loading_widget.progressBar.hide()
            self.loading_widget.loadinglabel.show()
            self.titlebar.show()
            self.move_to_center()
            self.show_main_window()
        if (self.launch_mode == LaunchMode.AUTOMATIC):
            # self.setWindowFlags(Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint)
            self.resize(LOADINGWIDTH, LOADINGHEIGHT)
            self.loading_widget.progressBar.hide()
            self.loading_widget.loadinglabel.show()
            self.loading_widget.hide()
            self.move_to_center()
            self.hide()

    '''def paintEvent(self,event):
        painter=QPainter(self)
        painter.setRenderHint(QPainter.Antialiasing)
        painter.setBrush(QBrush(Qt.white))
        painter.setPen(Qt.transparent)
        rect = self.rect()
        rect.setWidth(rect.width())
        rect.setHeight(rect.height())
        painter.drawRoundedRect(rect, 6, 6)'''

    #
    # 函数：初始化动画效果
    #
    def init_main_animation(self):

        '''
        topAnimation = QPropertyAnimation(self.title_widget, "pos")
        topAnimation.setDuration(1000)
        topAnimation.setStartValue(QPoint(0,-114))
        topAnimation.setEndValue(QPoint(0,0))
        '''

        bottomAnimation = QPropertyAnimation(self.bottom_widget, b"pos")
        bottomAnimation.setDuration(1000)
        bottomAnimation.setStartValue(QPoint(0, 620))
        bottomAnimation.setEndValue(QPoint(0, 60))

        '''
        updatetopOrigAnimation = QPropertyAnimation(self.update_top_widget, "pos")
        updatetopOrigAnimation.setDuration(1000)
        updatetopOrigAnimation.setStartValue(QPoint(0, 0))
        updatetopOrigAnimation.setEndValue(QPoint(0, -141))
        '''

        updatebottomOrigAnimation = QPropertyAnimation(self.update_bottom_widget, b"pos")
        updatebottomOrigAnimation.setDuration(1000)
        updatebottomOrigAnimation.setStartValue(QPoint(0, 60))
        updatebottomOrigAnimation.setEndValue(QPoint(0, 620))

        self.loadingAnimation = QPropertyAnimation(self.loading_widget, b"size")
        self.loadingAnimation.setDuration(1000)
        self.loadingAnimation.setStartValue(QSize(self.loading_widget.width(), self.loading_widget.height()))
        self.loadingAnimation.setEndValue(QSize(0, 0))

        self.mainGroup = QParallelAnimationGroup()
        # self.mainGroup.addAnimation(topAnimation)
        self.mainGroup.addAnimation(bottomAnimation)
        # self.mainGroup.addAnimation(updatetopOrigAnimation)
        # self.mainGroup.addAnimation(updatebottomOrigAnimation)
        # self.mainGroup.addAnimation(loadingAnimation)

        bottomOrigAnimation = QPropertyAnimation(self.bottom_widget, b"pos")
        bottomOrigAnimation.setDuration(1000)
        bottomOrigAnimation.setStartValue(QPoint(0, 60))
        bottomOrigAnimation.setEndValue(QPoint(0, 620))

        updatebottomAnimation = QPropertyAnimation(self.update_bottom_widget, b"pos")
        updatebottomAnimation.setDuration(1000)
        updatebottomAnimation.setStartValue(QPoint(0, 620))
        updatebottomAnimation.setEndValue(QPoint(0, 60))

        self.updateGroup = QParallelAnimationGroup(self)
        self.updateGroup.addAnimation(bottomOrigAnimation)
        self.updateGroup.addAnimation(updatebottomAnimation)
        # self.updateGroup.addAnimation(loadingAnimation)

        detailOrigAnimation = QPropertyAnimation(self.detail_widget, b"pos")
        detailOrigAnimation.setDuration(1000)
        detailOrigAnimation.setStartValue(QPoint(-336, 0))
        detailOrigAnimation.setEndValue(QPoint(0, 0))

        self.detailGroup = QParallelAnimationGroup(self)
        self.detailGroup.addAnimation(bottomOrigAnimation)
        self.detailGroup.addAnimation(detailOrigAnimation)

    #
    # 函数：信号槽绑定
    #
    def init_connect(self):
        # self.title_widget.close_button.clicked.connect(self.slot_click_close_button)
        # self.title_widget.min_button.clicked.connect(self.slot_click_min_button)
        # self.title_widget.set_button.clicked.connect(self.slot_click_menu_button)
        self.loading_widget.cancel_btn.clicked.connect(self.exit_app)
        self.loading_widget.continue_btn.clicked.connect(self.slot_continue_scan)
        self.titlebar.close_button.clicked.connect(self.slot_click_close_button)
        self.titlebar.min_button.clicked.connect(self.slot_click_min_button)
        self.titlebar.set_button.clicked.connect(self.slot_click_menu_button)
        self.bottom_widget.lw_all_selection.itemClicked.connect(self.slot_click_update_item)
        self.bottom_widget.sp_selection.itemClicked.connect(self.slot_click_sp_update_item)
        self.bottom_widget.click_ordinary_main_cb.connect(self.slot_reset_ordinary_cb)
        self.bottom_widget.click_important_main_cb.connect(self.slot_reset_important_cb)
        self.update_bottom_widget.lw_all_selection.itemClicked.connect(self.slot_click_install_item)
        self.update_bottom_widget.sp_selection.itemClicked.connect(self.slot_click_sp_install_item)
        self.bottom_widget.click_main_cb.connect(self.slot_reset_cb)
        self.bottom_widget.layout_all_cb.label_update.clicked.connect(self.slot_click_install_button)
        self.bottom_widget.layout_all_cb.label_cancel.clicked.connect(self.slot_click_cancel_button)
        self.detail_widget.title_bar.min_button.clicked.connect(self.slot_click_min_button)
        self.detail_widget.title_bar.close_button.clicked.connect(self.slot_click_close_button)
        self.update_succuss_widget.close_btn.clicked.connect(self.slot_click_tip_close_button)
        self.animation_msg_box.quitSignal.connect(self.exit_app)
        # self.connect(self.iface, Signals.dbus_process_msg, self.slot_dbus_process_msg)
        self.iface.dbus_process_msg.connect(self.slot_dbus_process_msg)
        self.down_deb_finish.connect(self.slot_down_deb_finish)
        self.iface.apt_start.connect(self.slot_apt_start)
        self.iface.apt_finish.connect(self.slot_apt_finish)
        self.iface.down_dep_finish.connect(self.slot_install_debpkg)
        self.iface.deb_copy_finish.connect(self.slot_copy_deb_finish)
        self.get_down_progress.connect(self.slot_send_progress)

        self.timer.timeout.connect(self.slot_timeout)
        self.sp_timer.timeout.connect(self.slot_sptimer_timeout)
        self.exit_time.timeout.connect(self.exit_app)
        self.kum_time.timeout.connect(self.slot_kum_finish_tiomeout)

        self.signal_show_exit.connect(self.show_exit_widget)
        self.change_loading_tiplabel.connect(self.slot_change_tiplabel)
        self.kum_update_finish.connect(self.slot_kum_update_finish)
        self.clean_sp_widget.connect(self.slot_clean_spwidget)
        self.installed_deb_finish.connect(self.slot_install_debpkg)
        self.db_insert_thread.exit_app.connect(self.exit_app_and_dbus)

    #
    # 函数：初始化日志模块
    #
    def init_log(self):
        # log_manager.init_log()
        self.is_log_init = True

    #
    # 函数：保证单例模式
    #
    def check_singleton(self):
        try:
            bus = dbus.SessionBus()
        except:
            LogManager.CRI(_("Dbus Initialize Failed, Program Quit."))
            sys.exit(0)

        # 已有实例在运行，将其显示到前端
        try:
            proxy_obj = bus.get_object(SINTERFACE, SINTERFACES)
            iface = dbus.Interface(proxy_obj, SINTERFACE)
            iface.bring_to_front()
            # 退出重复运行的当前实例
            sys.exit(0)

        # 没有实例在运行，创建一个dbus
        except dbus.DBusException:
            bus_name = dbus.service.BusName(SINTERFACE, bus)
            self.dbusControler = UtilDbus(self, bus_name)

    #
    # 函数：获取麒麟操作系统服务序列号
    #
    def check_service_key(self):
        if (self.cu.is_os_community() == True):
            self.service_key = "kylin"
            self.hash_pwd = "123123"
        else:
            print(_("Geting Service Serial Number..."))
            self.service_key = self.cu.get_service_key()
            self.hash_pwd = self.cu.get_hash_pwd()

            if self.service_key is None:
                LogManager.ERR(_("Get Service Serial Number Failed, Program Quit!"))
                if (self.launch_mode == LaunchMode.AUTOMATIC):
                    self.exit_app(_("Get Service Serial Number Failed, Program Quit!"))
                else:
                    qb = QMessageBox(self)
                    qb.setIcon(QMessageBox.Question)
                    qb.setWindowTitle("授权文件异常")
                    # qb.setText("当前连接的服务器或光盘中没有完全匹配的软件源。\n是否选择其中的默认软件源进行升级？\n\n这可能会导致未知的后果，请向技服人员确认。")
                    qb.setText(_("Get Service Serial Number Failed, Program Quit!"))
                    qb.setStandardButtons(QMessageBox.Yes)
                    qb.addButton(QPushButton("OK"), QMessageBox.YesRole)
                    # buttonYes = qb.button(self, QMessageBox.YesRole)
                    # buttonYes.setText("ok")
                    # qb.setButtonText(QMessageBox.Yes, QString(_("OK")))
                    rtn = qb.exec_()
                    self.close()
                    sys.exit(_("Get Service Serial Number Failed, Program Quit!"))

    #
    # 函数：收集客户端信息发送给php服务器
    #
    def pingback(self,_appname = "" , _appversion = "" , _statue = ''):
        host_ip, version, soft_version, host_mac = '','','',''
        appname = _appname
        appversion = _appversion
        statue = _statue
        # 获取本机ip
        try:
            s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
            s.connect(('8.8.8.8', 80))
            host_ip = s.getsockname()[0]
        except:
            host_ip = 'Ip failed to get'
        # 获取系统版本
        with open('/etc/lsb-release', 'r') as f:
            for line in f:
                if line.strip().startswith('DISTRIB_KYLIN_RELEASE='):
                    version = line.strip().split('=')
                    version = version[1]
        # 获取软件版本
        output = os.popen('dpkg -l|grep kylin-update-m').readlines()
        if output:
            soft_version = output[0].strip().split()
            soft_version = soft_version[2]

        # 获取时间
        nowtime = time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time()))

        # 获取Mac
        mac = uuid.UUID(int=uuid.getnode()).hex[-12:]
        host_mac = ":".join([mac[e:e + 2] for e in range(0, 11, 2)])

        send_data = {'ip': host_ip, 'version': version, 'soft_version': soft_version, 'datetime': nowtime,
                     'host_mac': host_mac,"appname":appname,"appversion":appversion,"status": statue}
        send_data_urlencode = urllib.parse.urlencode(send_data).encode(encoding="UTF-8")
        #print(send_data_urlencode)
        requrl = PINGBACK_URL
        try:
            kmg = urllib.parse.urlencode({'ip': host_ip, 'version': version, 'soft_version': soft_version, 'datetime': nowtime,
                     'host_mac': host_mac,'appname': appname, 'appversion':appversion,'status': statue})
            url = PINGBACK_URL+kmg
            print(url)
            req = urllib.request.urlopen(url=url)

            print("open")
            # req = urllib3.Request(url=requrl, data=send_data_urlencode)
            res_add = urllib.request.urlopen(req)
            # res_ddd = urllib3.urlopen(req)
        except Exception as e:
            print(_("Pingback failed."), e)

    #
    # 函数：准备工作
    #
    def pre_work(self):
        # 修复可能出现的dpkg问题，卸载可能存在的SP升级包，完成后由slot_dbus_process_msg() 执行 main_work()
        print(_("executing dpkg configure."))
        self.iface.call_configure_dpkg_by_shell()

    #
    # 函数：主流程
    #
    def main_work(self):
        #self.pingback()
        if (self.kus.check_available_medium() == True):
            if (self.kus.is_sinfo_down_success == True):
                if (self.kus.is_sinfo_match == True):
                    self.check_status()
                    print("check_statues")
                else:
                    qb = QMessageBox(self)
                    qb.setIcon(QMessageBox.Question)
                    # qb.setWindowTitle("没有匹配的源")
                    qb.setWindowTitle(_("No Matching Source"))
                    # qb.setText("当前连接的服务器或光盘中没有完全匹配的软件源。\n是否选择其中的默认软件源进行升级？\n\n这可能会导致未知的后果，请向技服人员确认。")
                    qb.setText(_(
                        "The connected server or CD does not have matched software source.\nDo you want to select the default software source to upgrade?\n\nThe operation may cause unknow result, please confirm to technocrat."))
                    qb.setStandardButtons(QMessageBox.Yes | QMessageBox.No)
                    qb.setButtonText(QMessageBox.Yes, str(_("OK")))
                    qb.setButtonText(QMessageBox.No, str(_("Cancel")))
                    rtn = qb.exec_()

                    if (rtn == QMessageBox.Yes):
                        self.check_status()
                    else:
                        self.set_default_sourceslist()
                        self.exit_app(_("User Cancel, Program Quit."))

            # 下载sinfo失败
            else:
                self.set_default_sourceslist()

                if (self.kus.is_sinfo_match == False):
                    if (self.launch_mode == LaunchMode.AUTOMATIC):
                        # self.exit_app("媒介中没有可用的软件源，程序退出.")
                        self.exit_app(_("No software source available, Program Quit."))
                    else:
                        # self.animation_msg_box.set_animation_args("媒介中没有可用的软件源，程序退出", True)
                        # self.show_exit_widget(_("No software source available"))
                        # self.signal_show_exit.emit(_("No software source available"))
                        self.loading_widget.change_layout.emit(_("No software source available"))
                else:
                    if (self.launch_mode == LaunchMode.AUTOMATIC):
                        # self.exit_app("下载软件源信息出错，程序退出.")
                        self.exit_app(_("Error when downloading info of software source, Program Quit."))
                    else:
                        # self.animation_msg_box.showAnimation(5000)
                        # self.show_exit_widget(_("Error when downloading info of software source"))
                        self.signal_show_exit.emit(_("Error when downloading info of software source"))

        # 找不到可用的升级媒介
        else:
            self.set_default_sourceslist()

            if (self.launch_mode == LaunchMode.AUTOMATIC):
                # self.exit_app("没有可用的升级媒介，程序退出.")
                self.exit_app(_("No upgrade media available, Program Quit."))
            else:
                # self.animation_msg_box.showAnimation(5000)
                # self.show_exit_widget(_("No upgrade media available"))
                self.signal_show_exit.emit(_("No upgrade media available"))

    #
    # 函数：检测apt update、自我升级、系统升级
    #
    def check_status(self):
        print("修改soucelist")
        # 修改sourceslist
        self.available_source = self.kus.available_source
        #try:
        lines = self.kus.get_sources()
        self.iface.change_source_list_to_kylin_update(lines)
        print("修改soucelist结束")
        '''except:
            if self.launch_mode == LaunchMode.AUTOMATIC:
                self.exit_app("")
            # self.show_exit_widget(_("Missing sinfo file"))
            self.signal_show_exit.emit(_("Missing sinfo file"))'''

        #try:
        # 需要apt-get update
        if (self.kus.check_need_apt_get_update() == True):
            # 执行apt-get update，False代表完成后由slot_dbus_process_msg() 执行 check_update_type()
            self.iface.call_update_source_by_shell(False)
        else:
            self.kus.check_update_type()
        '''except:
            if self.launch_mode == LaunchMode.AUTOMATIC:
                self.exit_app()
            # self.show_exit_widget(_("Missing sinfo file"))
            self.signal_show_exit.emit(_("Missing sinfo file"))'''

    #
    # 函数：任务分支
    #
    def switch_task(self, is_kylin_update, is_kum_update):
        # 可能的apt-get update已完成，告知dbus后台初始化apt库

        self.iface.call_init_cache()
        if self.is_created == False:
            # pyqt缺陷，密集执行函数时初始化trayicon很容易导致trayicon大小异常
            # 不得已将trayicon的初始化放此处，在大部分任务处理完之后
            self.tray_icon = SystemTray(self)
            self.is_created = True

        if (is_kum_update == True):
            self.task_mode = TaskMode.UPDATEKUM
        else:
            if (is_kylin_update == True):
                self.task_mode = TaskMode.UPDATEOS
            else:
                self.task_mode = TaskMode.UPDATEPKG

        # 更新管理器自我升级流程
        if (self.task_mode == TaskMode.UPDATEKUM):
            # self.tray_icon.start_tray_msg("正在升级更新管理器.")
            # self.tray_icon.start_tray_msg(_("Upgrading Update Manager."))
            self.change_loading_tiplabel.emit(_("Detected"), True)
            self.is_working_c = True
            self.iface.call_upone("kylin-update-manager")

        # 系统升级流程
        elif (self.task_mode == TaskMode.UPDATEOS):
            # 提示进行系统升级
            self.move_to_center()
            self.show_main_window()
        # 包升级流程
        else:
            self.kus.start_access()

    #
    # 函数：显示自我升级
    #
    def slot_kum_update_finish(self):
        self.loading_widget.loadinglabel.hide()
        self.loading_widget.appname_label.hide()
        self.loading_widget.label1.hide()
        self.loading_widget.update_tip.show()
        self.loading_widget.update_tip.setText(_("Update Succesed."))
        self.loading_widget.tiplabel.setText(_("Automatically restart the update manager in three seconds"))

    #
    # 函数：自我升级完成，退出dbus，重启更新管理器
    #
    def kylin_update_manager_upgrade_finish(self):
        self.kum_update_finish.emit()
        self.kum_time.start(3000)

    #
    # 函数：重启更新管理器
    #
    def slot_kum_finish_tiomeout(self):
        self.kum_time.stop()
        if self.iface:
            self.iface.exit_dbus()

        if self.launch_mode == LaunchMode.AUTOMATIC:
            os.system("kylin-update-manager-restart -auto &")
        else:
            os.system("kylin-update-manager-restart -m &")

        self.close()
        sys.exit("Update Manager Restart.")

    #
    # 函数：修复配置文件冲突，默认选择Yes
    #
    def fix_conffile(self):
        print(_("fixing conffile."))
        self.iface.call_fix_conffile()

    #
    # 函数：安装kylin-update完成，执行并退出更新管理器
    #
    def kylin_update_install_finish(self):
        if os.path.isfile("/usr/share/kylin-update-desktop/kylin-simpleupdate"):
            os.system("/usr/share/kylin-update-desktop/kylin-simpleupdate &")
        elif os.path.isfile("/tmp/kylin-update/kylin-simpleupdate"):
            os.system("/tmp/kylin-update/kylin-simpleupdate &")
        self.exit_app(_("System upgrade start, Update Manager Quit."))

    #
    # 函数：软件安装完成后，需要拉起的软件运行其启动命令
    #
    def run_software(self):
        for line in RUNLIST:
            run_command = line + " &"
            os.system(run_command)
        self.exit_app(_("Update succeed..."))

    #
    # 函数：将sources.list.kumbak还原为sources.list
    #
    def set_default_sourceslist(self):
        print("# restore /etc/apt/sources.list and do apt-get update")
        self.iface.change_source_list_to_default()
        # self.iface.call_update_source_by_shell(True)#lixiang

    '''
    Dbus Apt后台信号统一处理函数
    信号传递顺序：
    daemon.kum_fetch_signal() / kum_apt_signal()
    dbus_service.slot_kum_fetch_signal() / slot_kum_apt_signal()
    self.slot_dbus_process_msg()
    '''

    def slot_dbus_process_msg(self, signal_type, app_name, action, percent, process_type, status):
        print(app_name, " : ", signal_type, " : ", process_type, " : ", str(percent), " : ", status, " : ", action)
        # conffile冲突
        if process_type == "apt_conffile":
            self.is_conffile = True

        # 错误信号,有conffile时暂不处理
        if process_type == "apt_error" and self.is_conffile == False:
            self.is_working = False
            self.is_error = True
            if app_name == "#update" or app_name == "#update-shell":
                self.set_default_sourceslist()
                # self.animation_msg_box.set_animation_args("源更新失败，程序将在5秒后退出.", True)
                LogManager.INFO(_("Update source failed, five seconds later, Program will quit."))
                # self.show_exit_widget(_("Update source failed"))
                self.signal_show_exit.emit(_("Update source failed"))

            else:
                # 有包无法下载
                if (str(percent) == "-99.0"):
                    msgToShow = status + " " + _("Update software failed, five seconds later, Program will quit.")
                    print("app_name:   "+app_name)
                    app_list = []
                    num = 0
                    statue_list = []
                    if(self.will_install == False):
                        for i in self.App_Version_list:
                            if i["name"] in app_name:
                                app_list.insert(num,i)
                                statue_list.insert(num,"Fail")
                                num+=1
                        self.db_insert_thread.get_variable(app_list, "Fail", _("Update service pack failed"),statue_list)
                        self.db_insert_thread.start()

                    LogManager.INFO(msgToShow)
                    # self.show_exit_widget(_("Update software failed"))
                    # self.set_default_sourceslist()
                    #self.signal_show_exit.emit(_("Update software failed"))

                else:
                    # 升级流程时出错,自动退出.
                    if (self.task_mode == TaskMode.UPDATEOS):
                        # self.animation_msg_box.set_animation_args("SP补丁更新错误，程序将在5秒后退出.", True)
                        LogManager.INFO(_("Update service pack failed, five seconds later, Program will quit."))
                        app_list = []
                        num = 0
                        statue_list = []
                        for i in self.App_Version_list:
                            if i["name"] in app_name:
                                app_list.insert(num,i)
                                statue_list.insert(num,"Fail")
                                num+=1
                        self.db_insert_thread.get_variable(app_list, "Fail",_("Update service pack failed"),statue_list)
                        self.db_insert_thread.start()
                        #self.set_default_sourceslist()
                        # self.show_exit_widget(_("Update service pack failed"))
                        #self.signal_show_exit.emit(_("Update service pack failed"))
                    else:
                        self.is_error = False
                        self.is_working_install = False
                        self.will_install = False
                        app_list = []
                        num = 0
                        statue_list = []
                        for i in self.App_Version_list:
                            if i["name"] == app_name:
                                if(i["name"] in self.install_fail_list):
                                    pass
                                else:
                                    if(i["name"] not in self.install_fail_list):
                                        self.install_fail_list.append(i["name"])
                                self.slot_dbus_process_msg("apt", "#install_and_upgrade", "", 100.0,"apt_finish", "")
                                break
                            num+=1

                        # self.animation_msg_box.set_animation_args("软件更新失败，程序将在5秒后退出.", True)
                        LogManager.INFO(_("Update software failed, five seconds later, Program will quit."))
                        # self.show_exit_widget(_("Update software failed"))
                        #self.signal_show_exit.emit(_("Update software failed"))

        # 调用本地命令dpkg --configure -a过程的信号
        if app_name == "#configure-shell":
            if process_type == "finish" and str(percent) == "200.0":
                # dpkg --configure -a完成，开始执行main work
                # self.loading_widget.tiplabel.setText("正在从源中更新数据...")
                # self.loading_widget.tiplabel.setText(_("Updating data from source..."))
                self.change_loading_tiplabel.emit(_("Updating data from source..."), False)
                self.thread_work = Thread_work(self)
                self.thread_work.start()
                # self.main_work()

        # 调用本地命令apt-get update过程的信号
        if app_name == "#update-shell":
            if process_type == "finish" and str(percent) == "200.0":
                print("!!  一次apt-get update完成，模式：", action)
                # 0既传入的False，代表非quiet，开始检测是否有系统版本升级
                if action == "0":
                    self.kus.check_update_type()

        # 更新管理器自我升级的信号，kylin-update-manager包安装完成，重启自身和dbus后台
        if app_name == "kylin-update-manager":
            if process_type == "apt_finish" and str(percent) == "100.0":
                app_list = []
                num = 0
                for i in self.App_Version_list:
                    if i["name"] == app_name:
                        app_list.insert(num,i)
                num = num+1
                self.get_app_changelog(i,"success")
                LogManager.INSTALL(("installed " + app_name + ' ' + i['version']))

                self.kylin_update_manager_upgrade_finish()

        # 系统升级流程的信号，kylin-update包安装完成，执行系统升级
        if app_name == "kylin-update-desktop" or app_name == "kylin-update-server":
            if process_type == "apt_finish" and str(percent) == "100.0":
                app_list = []
                num = 0
                for i in self.App_Version_list:
                    if i["name"] == app_name:
                        app_list.insert(num, i)
                num = num +1
                self.pingback(i["name"],i["version"],"success")
                self.kylin_update_install_finish()

        # 调用本地命令fix conffile过程的信号
        if app_name == "#fix-conffile-shell":
            if self.is_working_c == True:
                LogManager.INFO(_("Crucial update successed..."))
                self.is_working_c = False
                self.detail_widget.pb_fetch.setValue(0)
                self.detail_widget.pb_apt.setValue(0)
                self.update_bottom_widget.te_description.clear()
                self.tray_icon.hide()

                if self.isHidden() == True:
                    self.set_default_sourceslist()
                    # self.show_exit_widget(_("Update Succesed."))
                    self.signal_show_exit.emit(_("Update Succesed."))
            else:
                LogManager.INFO(_("Ordinary and Important update successed..."))
                self.is_working = False
                self.detail_widget.pb_apt.setValue(100)
                self.update_bottom_widget.te_description.append(_("Update Succesed."))
                self.set_default_sourceslist()
                # self.animation_msg_box.set_animation_args(_("Update succeed, five seconds later, Program will quit."),True)
                # self.animation_msg_box.showAnimation(5000)
                # self.show_exit_widget(_("Update Succesed."))
                self.signal_show_exit.emit(_("Update Succesed."))
        # 包升级过程的信号
        else:
            # 下载过程
            if signal_type == "fetch":
                if process_type == "down_start":
                    self.detail_widget.pb_fetch.setValue(0)
                elif process_type == "down_stop":
                    self.detail_widget.pb_fetch.setValue(100)
                else:
                    if "down_pulse" in process_type:
                        # apt会重复打印信息，过滤掉
                        if process_type != self.previous_process_type:
                            self.previous_process_type = process_type
                            # self.update_bottom_widget.te_description.append(process_type.split(" ")[1])
                    if percent not in [0.0, "0.0", None]:
                        self.detail_widget.pb_fetch.setValue(int(percent))
                        self.tray_icon.process_now = str(int(percent) / 2)

            # 安装过程
            elif signal_type == "apt" and process_type == "apt_start":
                self.detail_widget.pb_apt.setValue(0)
                # self.update_bottom_widget.te_description.append(status)
                # self.update_bottom_widget.te_description.append(_("Installing..."))


            # 安装结束
            elif app_name == "#install_and_upgrade" and signal_type == "apt" and process_type == "apt_finish" and str(percent) == "100.0" and self.is_error == False:
                print("helloooooooooooooooooooooooooooooooo")
                print(self.work_list)
                print(self.Wait_install_list)
                print(self.app_install_statue_list)
                print("暂停的软件包还有")
                print(self.puase_down_list)
                self.is_working_install = False
                self.will_install = False
                app_list = []
                statue_list = []
                num = 0
                for pkg in PKGLIST:
                    for i in self.App_Version_list:
                        if i["name"] == pkg:
                            app_list.insert(num, i)
                            statue_list.insert(num, "success")
                            num = num + 1
                            LogManager.INSTALL(("installed " + pkg + ' ' + i['version']))
                    if(pkg in self.puase_down_list):
                        self.puase_down_list.remove(pkg)
                        n = 0
                        for j in self.app_install_statue_list:
                            if (i["name"] == j["name"]):
                                self.app_install_statue_list[n]["is_puase"] = False
                            n = n+1
                print("暂停的软件包还有")
                print(self.puase_down_list)
                print(PKGLIST)
                #get_changelog = Thread_get_changelog(app_list,"Seccuss","",self)
                if(self.is_working_c == True):
                    print(self.c_work_list)
                    if (len(self.Wait_install_list) == 0):
                        if (len(self.c_work_list) != 0):
                            down_appname = self.c_work_list.pop(0)
                            pool.submit(self.down_deb_pkg, down_appname)
                        else:
                            if (len(self.install_fail_list) == 0):
                                PKGLIST.clear()
                                self.db_insert_thread.get_variable(app_list, "success", "", statue_list)
                                self.db_insert_thread.start()
                            else:
                                for pkg in self.install_fail_list:
                                    for i in self.App_Version_list:
                                        if (i["name"] == pkg):
                                            app_list.insert(num, i)
                                            statue_list.insert(num, "Fail")
                                PKGLIST.clear()
                                if(len(self.install_fail_list) == 1 and self.install_fail_list["name"] == "kylin-update-manager"):
                                    self.db_insert_thread.get_variable(app_list, "Fail", _("Update software failed"), statue_list)
                                    self.db_insert_thread.start()
                                else:
                                    self.db_insert_thread.get_variable(app_list, "success", "", statue_list)
                                    self.db_insert_thread.start()
                    else:
                        print("h22222222222222")
                        if(len(self.c_work_list)==0):
                            self.will_install = True
                            install_app = self.Wait_install_list.pop(0)
                            appname_list = install_app.split("_")
                            appname = appname_list[0]
                            print("等待安装软件")
                            print(self.Wait_install_list)
                            print("即将安装")
                            print(appname)
                            p = pool.submit(self.iface.call_install_and_upgrade,appname)
                            #self.iface.call_install_and_upgrade(appname)
                        else:
                            down_appname = self.c_work_list.pop(0)
                            pool.submit(self.down_deb_pkg, down_appname)
                            self.will_install = True
                            install_app = self.Wait_install_list.pop()
                            appname_list = install_app.split("_")
                            appname = appname_list[0]
                            self.installed_deb_finish.emit()
                else:
                    if(len(self.Wait_install_list)==0):
                        if(len(self.work_list)!=0):
                            #if(self.is_downloading == False):
                            print("没有等待安装的，但是还有没下载完的")
                            print(self.work_list)
                            down_appname = self.work_list.pop(0)
                            pool.submit(self.down_deb_pkg, down_appname)
                        else:
                            puase = False
                            if(self.will_install == False):
                                for i in self.app_install_statue_list:
                                    if(i["is_puase"]==True):
                                        puase=True
                                        break
                                if(puase == False):
                                    if(len(self.install_fail_list) == 0 and len(self.puase_down_list)==0 and len(self.App_Version_list)==0):
                                        PKGLIST.clear()
                                        self.db_insert_thread.get_variable(app_list,"success",_("Update software failed"),statue_list)
                                        self.db_insert_thread.start()
                                    else:
                                        if(len(self.puase_down_list)==0):
                                            for pkg in self.install_fail_list:
                                                for i in self.App_Version_list:
                                                    if(i["name"] == pkg):
                                                        app_list.insert(num,i)
                                                        statue_list.insert(num,"Fail")
                                            PKGLIST.clear()
                                            self.db_insert_thread.get_variable(app_list, "success", "",statue_list)
                                            self.db_insert_thread.start()
                    else:
                        if(len(self.work_list) == 0 ):
                            print("下载结束，还有没安装的：")
                            print(self.Wait_install_list)
                            print("\n")
                            self.will_install = True
                            self.installed_deb_finish.emit()
                        else:
                            print("没有下载完，也没有安装结束")
                            print(self.Wait_install_list)
                            print(self.work_list)
                            print("\n")
                            down_appname = self.work_list.pop(0)
                            pool.submit(self.down_deb_pkg, down_appname)
                            self.will_install = True
                            self.installed_deb_finish.emit()


            # 流程pulse
            else:
                if signal_type == "apt" and process_type == "apt_pulse":
                    if (app_name not in PKGLIST) and (app_name not in ("dpkg-exec", "fontconfig", "dbus")):
                        PKGLIST.append(app_name)
                    self.detail_widget.pb_apt.setValue(int(percent))
                    self.tray_icon.process_now = str(50 + (int(percent) / 2))

    #
    #函数：app_name == "#install_and_upgrade"安装结束，percent = 100%之后的流程
    #
    def update_seccuss(self,ret):
        print(ret)
        if self.is_conffile == True:
            self.fix_conffile()
        else:
            if self.is_working_c == True:
                LogManager.INFO(_("Crucial update successed..."))
                self.is_working_c = False
                self.detail_widget.pb_fetch.setValue(0)
                self.detail_widget.pb_apt.setValue(0)
                # self.update_bottom_widget.te_description.clear()
                self.tray_icon.hide()

                if self.isHidden() == True:
                    self.set_default_sourceslist()
                    if RUNLIST:
                        self.run_software()
                    # self.animation_msg_box.set_animation_args( _("Update succeed, five seconds later, Program will quit."), True)
                    # self.animation_msg_box.showAnimation(5000)
                    # self.show_exit_widget(_("Update Succesed."))
                    if (ret == "success"):
                        self.signal_show_exit.emit(_("Update Succesed."))
                    else:
                        self.signal_show_exit.emit(_("Download dependency failed"))
            else:
                LogManager.INFO(_("Ordinary and Important update successed..."))
                self.is_working = False
                self.detail_widget.pb_apt.setValue(100)
                # self.update_bottom_widget.te_description.append(_("Update Succesed."))
                self.set_default_sourceslist()
                if RUNLIST:
                    self.run_software()
                # self.animation_msg_box.set_animation_args(_("Update succeed, five seconds later, Program will quit."), True)
                # self.animation_msg_box.showAnimation(5000)
                # self.show_exit_widget(_("Update Succesed."))
                print(ret)
                if (ret == "success"):
                    self.signal_show_exit.emit(_("Update Succesed."))
                else:
                    self.signal_show_exit.emit(_("Download dependency failed"))


    #
    #函数：处理获取changelog
    #
    def get_app_changelog(self,i,statue):
        install_db = install_information()
        print("name = "+ i["name"])
        print("version = "+ i["version"])
        self.pingback(i["name"],i["version"],statue)
        file_name1 = "/usr/share/doc/" + i["name"] + "/changelog.gz"
        file_name2 = "/usr/share/doc/" + i["name"] + "/changelog.Debian.gz"
        filename = ""
        if (os.path.exists(file_name1)):
            filename = file_name1
        elif (os.path.exists(file_name2)):
            filename = file_name2
            print("changelog_filneme = "+ filename)
        try:
            description = ""
            if (self.kus.available_url.startswith("file") == False):
                cmd = "apt-get changelog " + i["name"]
                result = os.popen(cmd).readlines()
                k = 0
                for j in result:
                    if (i["version"] in j):
                        k=k+2
                        while ("--" not in result[k]):
                            if(result[k] != "\n" or result[k] != " \n" or result[k] != "  \n"):
                                result[k].strip("\n")
                                description = description + result[k]
                            k = k + 1
                        description = description +'\n'
                        break
                    k = k + 1
            if description == "":
                if (filename == ""):
                    if (statue == "Fail"):
                        install_db.insert(i["name"], i['version'],
                                          _("Unable to get changelog due to installation failure"),
                                          i["icon"], statue)
                    else:
                        install_db.insert(i["name"], i['version'], "", i["icon"], statue)
                    return
                try:
                    read_cmd = "zless "+filename
                    read_result = os.popen(read_cmd).readlines()
                    description = ""
                    k = 0
                    for m in read_result:
                        if (i["version"] in m):
                            k=k+2
                            while ("--" not in read_result[k]):
                                if (read_result[k] != "\n" or read_result[k] != " \n" or read_result[k] != "  \n"):
                                    read_result[k].strip("\n")
                                    description = description + read_result[k]
                                k = k + 1
                            break
                        k = k + 1
                    self.description = ""
                    self.description = description
                    install_db.insert(i["name"], i['version'], self.description, i["icon"], statue)
                except:
                    if(statue == "Fail"):
                        install_db.insert(i["name"], i['version'], _("Unable to get changelog due to installation failure"), i["icon"], statue)
                    else:
                        install_db.insert(i["name"], i['version'], "", i["icon"], statue)
            else:
                self.description = ""
                self.description = description
                install_db.insert(i["name"], i['version'], self.description, i["icon"], statue)
        except:
            if(filename == ""):
                if (statue == "Fail"):
                    install_db.insert(i["name"], i['version'], _("Unable to get changelog due to installation failure"),
                                      i["icon"], statue)
                else:
                    install_db.insert(i["name"], i['version'], "", i["icon"], statue)
                return
            open_cmd = "zless "+filename
            try:
                read_result = os.popen(open_cmd)
                description = ""
                k = 0
                for m in read_result:
                    if (i["version"] in m):
                        k=k+2
                        while ("--" not in read_result[k]):
                            if (read_result[k] != "\n" or read_result[k] != " \n" or read_result[k] != "  \n"):
                                read_result[k].strip("\n")
                                description = description + read_result[k]
                            k = k + 1
                        break
                    k = k + 1
                self.description = ""
                self.description = description
                install_db.insert(i["name"], i['version'], self.description, i["icon"], statue)
            except:
                if (statue == "Fail"):
                    install_db.insert(i["name"], i['version'], _("Unable to get changelog due to installation failure"),
                                      i["icon"], statue)
                else:
                    install_db.insert(i["name"], i['version'], "", i["icon"], statue)



    #
    # 函数：所有更新信息获取完成
    #
    def slot_access_completed(self, size_byte_o, size_byte_i, len_o, len_i, crucial_list):
        self.crucial_list = crucial_list
        # 没有任何更新
        if (len_o == 0 and len_i == 0 and len(crucial_list) == 0):
            # self.hide()
            self.set_default_sourceslist()
            self.pingback("","",_("information acquisition"))
            if self.launch_mode == LaunchMode.MANUAL:
                # self.show_exit_widget(_("No software need updated"))
                self.loading_widget.change_layout.emit(_("No software need updated"))
                self.clean_sp_widget.emit()
            else:
                if self.click_cancel == True:
                    self.loading_widget.change_layout.emit(_("No software need updated"))
                    self.clean_sp_widget.emit()
                # self.hide()
                else:
                    # self.exit_app("没有可用的更新.")
                    self.exit_app(_("No updated available."))
        else:
            self.app_num_ordinary = len_o
            self.app_num_important = len_i
            self.selected_num_ordinary = len_o
            self.selected_num_important = len_i
            self.size_ordinary = size_byte_o
            self.size_important = size_byte_i

            # 优先安装关键更新
            if (len(crucial_list) > 0):
                if (self.launch_mode == LaunchMode.AUTOMATIC):
                    # self.tray_icon.start_tray_msg("正在执行关键更新.")
                    self.tray_icon.start_tray_msg(_("Installing crucial update."))
                self.is_working_c = True
                for app in crucial_list:
                    self.c_work_list.append(app)
                    print(self.c_work_list)
                    self.kus.at.ca.open()
                    app_msg = self.kus.at.ca[app]
                    upkg = UPackage(app_msg)
                    self.kus.at.fill_info_cn(upkg)
                    self.kus.at.oneAppMsg.emit({"apptype":AppType.CRUCIAL, "displayName":upkg.displayName,
                                                "name":upkg.name, "icon":upkg.icon, "downloadSizeHuman":upkg.downloadSizeHuman,
                                                "downloadSize":upkg.downloadSize, "installedVersion":upkg.installedVersion,
                                                "architecture": app_msg._pkg.architecture,"candidateVersion":upkg.candidateVersion,
                                                "description":upkg.description,"fullversion":upkg.candidateVersion})
                pkg = self.c_work_list.pop(0)
                self.thread1 = pool.submit(self.down_deb_pkg,pkg)
                #self.thread_get_deb.get_appname(pkg)
                #self.thread_get_deb.run()
                #self.down_deb_pkg(app)
                    #self.iface.call_install_and_upgrade(app)

            if len_o > 0 and len_i > 0:
                self.change_display_content(LWMode.BOTH)
            elif len_o == 0 and len_i > 0:
                self.change_display_content(LWMode.IMPORTANT)
            elif len_o > 0 and len_i == 0:
                self.change_display_content(LWMode.ORDINARY)
            elif len_o == 0 and len_i == 0:
                # hide表示只有关键更新
                self.hide()

            print(_("Ordinary update : "), len_o, _(",Important update : "), len_i, _(",Crucial update : "),
                  len(crucial_list))

    #
    # 函数：显示继续扫描界面
    #
    def slot_change_layout(self, string):
        self.bottom_widget.hide()
        self.loading_widget.loadinglabel.hide()
        self.loading_widget.tiplabel.hide()
        self.loading_widget.errorlabel.show()
        self.loading_widget.errorlabel.move(155, 95)
        self.loading_widget.errorlabel.setText(string)
        self.loading_widget.cancel_btn.show()
        self.loading_widget.cancel_btn.move(315, 215)
        self.loading_widget.continue_btn.show()
        self.loading_widget.continue_btn.move(430, 215)
        self.loading_widget.setFixedSize(550, 280)
        self.loading_widget.move(0, 40)
        self.loading_widget.show()

    #
    # 函数：清除sp列表
    #
    def slot_clean_spwidget(self):
        self.bottom_widget.sp_selection.clear()

    #
    # 函数：每获得一个app信息
    #
    def slot_get_one_app(self, msg):
        app_msg = AppMsg()
        app_msg.ZH_CN_NAME = msg["displayName"]
        app_msg.NAME = msg["name"]
        app_msg.ICON = msg["icon"]
        app_msg.SIZE = msg["downloadSizeHuman"]
        app_msg.BYTESIZE = msg["downloadSize"]
        app_msg.INSTALLEDVERSION = msg["installedVersion"]
        app_msg.CANDIDATEVERSION = msg["candidateVersion"]
        app_msg.DESCRIPTION = msg["description"]
        app_msg.ARCHITECTURE = msg["architecture"]
        app_msg.FULLVERSION = msg["fullversion"]
        App_Version_dic = {'name': '', 'version': '',"description":'',"icon":'',"architecture":'',"fullversion":''}
        App_Version_dic["name"] = app_msg.NAME
        App_Version_dic["version"] = app_msg.CANDIDATEVERSION
        App_Version_dic["description"] = app_msg.DESCRIPTION
        App_Version_dic["architecture"] = app_msg.ARCHITECTURE
        App_Version_dic["fullversion"] = app_msg.FULLVERSION
        App_Version_dic["icon"] = app_msg.ICON
        self.App_Version_list.insert(self.App_install_num, App_Version_dic)
        self.App_install_num += 1
        if msg['apptype'] == AppType.ORDINARY:
            self.add_ordinary_item(app_msg)
        elif msg['apptype'] == AppType.IMPORTANT:
            self.add_important_item(app_msg)
        elif msg['apptype'] == AppType.SP:
            self.add_sp_item(app_msg)

    #
    # 函数：搜索
    #
    def slot_textChanged(self):
        self.menu.order_statue = 0
        select_text = self.menu.log_widget.search_line.text()
        self.menu.is_search = False
        self.menu.log_widget.search_widget.setStyleSheet(".QWidget{background-color:#ffffff;border:1px solid #3d6be5;}")
        self.menu.log_widget.search_image.setStyleSheet("QPushButton{background-color:#ffffff;border:0px solid #cfcfcf;font-size:12px;color:#a0a0a0;image: url(./res/close1.png);}")
        #self.menu.log_widget.search_line.setStyleSheet("QLineEdit{border-radius:6px;background-color:white;border:1px solid #3d6be5;color:#444444;font-size:12px;}")
        self.menu.log_widget.local_infmation_list.clear()
        self.menu.log_widget.app_infmation_list.clear()
        installed_db = install_information()
        installed_db.search_select(select_text)
        self.show_selected_imformation(installed_db)
        installed_db.connect.commit()
        installed_db.cursor.close()
        installed_db.connect.close()
        self.menu.log_widget.show()

    #
    #函数:将搜索到的信息显示到界面
    #
    def show_selected_imformation(self,installed_db):
        res = installed_db.cursor.fetchall()

        if res == None:
            installed_db.connect.commit()
            installed_db.cursor.close()
            installed_db.connect.close()
        else:
            self.menu.log_widget.local_infmation_list.clear()
            self.menu.log_widget.app_infmation_list.clear()
            pass

        for item in res:

            appname = item[0]
            version = item[1]
            time = item[2]
            description = item[3]
            icon = item[4]
            statue = item[5]
            app_msg = AppMsg()
            app_msg.ZH_CN_NAME = ""
            app_msg.NAME = appname
            app_msg.SIZE = ""
            app_msg.BYTESIZE = ""
            app_msg.INSTALLEDVERSION = version
            app_msg.CANDIDATEVERSION = ""
            app_msg.DESCRIPTION = description
            if statue == "Fail":
                app_msg.STATUE = _("update failed")
            else:
                app_msg.STATUE = _("update seccussed")
            if os.path.exists(icon):
                app_msg.ICON = icon
            else:
                if (appname == "kylin-update-desktop"):
                    app_msg.ICON = "./res/SP_icon.png"
                elif (appname == "kylin-update-manager"):
                    app_msg.ICON = "./res/icon.png"
                else:
                    app_msg.ICON = "./res/soft_logo.png"
            item = QListWidgetItem()
            list_item = UpdateListItemWidget(app_msg,True, self)
            list_item.setStatusTip(str(app_msg.BYTESIZE))
            list_item.setFixedHeight(85)
            list_item.logolabel.hide()
            list_item.splitlabel.move(0,84)
            list_item.applabel.move(15,14)
            list_item.appdescribe.move(15,75)
            list_item.checkBox.hide()
            time1 = time.split()
            list_item.installed_time_label.setText(time1[0])
            list_item.installed_time_label.move(345, 40)
            list_item.installed_time_label.show()
            if(app_msg.STATUE == _("update failed")):
                list_item.install_statue.setStyleSheet("QLabel{font-size:12px;color:#d88888;border:0px solid #cfcfcf;}")
            list_item.install_statue.setText(app_msg.STATUE)
            list_item.install_statue.move(270, 40)
            list_item.install_statue.show()
            list_item.logolabel.hide()
            list_item.applabel.move(15, 14)
            list_item.applabel.setFixedWidth(240)
            list_item.appdescribe.move(15, 60)
            list_item.appdescribe.setFixedWidth(240)
            list_item.installed_versionlabel.move(15, 40)
            list_item.installed_versionlabel.setFixedWidth(240)
            list_item.installed_versionlabel.show()
            item.setWhatsThis(app_msg.DESCRIPTION)
            if (app_msg.NAME == "kylin-update-manager" or app_msg.NAME == "kylin-update-desktop"):
                list_item.logolabel.setFixedSize(48, 48)
                self.menu.log_widget.local_infmation_list.addItem(item)
                self.menu.log_widget.local_infmation_list.setItemWidget(item, list_item)
            else:
                self.menu.log_widget.app_infmation_list.addItem(item)
                self.menu.log_widget.app_infmation_list.setItemWidget(item, list_item)


    #
    # 函数：添加SP包到UI界面
    #
    def add_sp_item(self, app_msg):
        is_SP_update = True
        item = QListWidgetItem()
        list_item = UpdateListItemWidget(app_msg, self)
        list_item.setFixedHeight(80)
        list_item.checkBox.hide()
        list_item.sizelabel.hide()
        list_item.logolabel.setFixedSize(48, 48)
        list_item.logolabel.move(15, 15)
        list_item.applabel.move(83, 5)
        list_item.sizelabel.hide()
        list_item.applabel.setStyleSheet("QLabel{font-size:18px;color:#444444;border:0px solid #cfcfcf;}")
        list_item.installed_versionlabel.setText(_("current version:") + app_msg.INSTALLEDVERSION)
        list_item.installed_versionlabel.setStyleSheet("QLabel{font-size:12px;color:#444444;border:0px solid #cfcfcf;}")
        list_item.installed_versionlabel.move(83, 40)
        list_item.new_versionlabel.setText(_("new version:") + app_msg.CANDIDATEVERSION)
        list_item.new_versionlabel.setStyleSheet("QLabel{font-size:12px;color:#444444;border:0px solid #cfcfcf;}")
        list_item.new_versionlabel.move(83, 57)
        list_item.splitlabel.hide()
        list_item.setStatusTip(str(app_msg.BYTESIZE))
        if "KYDROID" in app_msg.CANDIDATEVERSION.upper().split('-'):
            is_SP_update = False
            list_item.installed_versionlabel.hide()
            list_item.new_versionlabel.move(83, 45)
        item.setWhatsThis(app_msg.DESCRIPTION)
        self.bottom_widget.sp_selection.addItem(item)
        self.bottom_widget.sp_selection.setItemWidget(item, list_item)
        self.item_map[app_msg.NAME] = list_item
        self.get_app_num += 1
        self.change_display_content(LWMode.SP, is_SP_update)

    #
    # 函数：将一个普通app添加到ui
    #
    def add_ordinary_item(self, app_msg):
        item = QListWidgetItem()
        list_item = UpdateListItemWidget(app_msg, self)
        list_item.setStatusTip(str(app_msg.BYTESIZE))
        list_item.installed_versionlabel.hide()
        item.setWhatsThis(app_msg.DESCRIPTION)
        list_item.size_change.connect(self.recalculate_ordinary_apps_size)
        list_item.checkBox.clicked.connect(self.set_checkbox)
        self.bottom_widget.lw_all_selection.addItem(item)
        self.bottom_widget.lw_all_selection.setItemWidget(item, list_item)
        self.item_map[app_msg.NAME] = list_item
        # item.isSelected.connect(self.slot_select_item(app_msg))

    #
    # 函数：将一个重要app添加到ui
    #
    def add_important_item(self, app_msg):
        item = QListWidgetItem()
        list_item = UpdateListItemWidget(app_msg, self)
        list_item.setStatusTip(str(app_msg.BYTESIZE))
        list_item.installed_versionlabel.hide()
        item.setWhatsThis(app_msg.DESCRIPTION)
        list_item.size_change.connect(self.recalculate_important_apps_size)
        list_item.checkBox.clicked.connect(self.set_checkbox)
        self.bottom_widget.lw_all_selection.addItem(item)
        self.bottom_widget.lw_all_selection.setItemWidget(item, list_item)
        self.item_map[app_msg.NAME] = list_item
        self.get_app_num += 1
        # self.bottom_widget.lw_all_selection.itemClicked.connect(self.slot_select_item)
        '''
        update_item = QListWidgetItem()
        update_list_item = downloadwidget(app_msg,False,self)
        self.update_bottom_widget.lw_all_selection.addItem(update_item)
        self.update_bottom_widget.lw_all_selection.setItemWidget(update_item, update_list_item)
        
        '''

    #
    # 函数：ui内容初始化
    #
    def change_display_content(self, lw_mode, is_sp_update=False):
        # self.top_widget.label_all_num.setText(str(self.app_num_ordinary + self.app_num_important))
        self.bottom_widget.layout_h_cb.label_num.setText(str(self.get_app_num))
        self.update_bottom_widget.layout_h_cb.label_num.setText(str(self.app_num_ordinary + self.app_num_important))
        size_all_human = self.cu.byte_human(self.size_ordinary + self.size_important)

        if lw_mode == LWMode.BOTH:
            size_ordinary_human = self.cu.byte_human(self.size_ordinary)
            size_important_human = self.cu.byte_human(self.size_important)
            self.bottom_widget.lw_all_selection.setCurrentRow(0)
            first_item = self.bottom_widget.lw_all_selection.item(0)
            # self.bottom_widget.te_description.setText(first_item.whatsThis())
            self.bottom_widget.lw_all_selection.show()
            self.bottom_widget.layout_all_cb.label_cancel.hide()
            self.bottom_widget.layout_all_cb.cb.show()
            self.bottom_widget.layout_all_cb.label_3.hide()
            self.bottom_widget.layout_all_cb.label_all_select.show()
            self.bottom_widget.layout_h_cb.cb.show()
            self.bottom_widget.layout_h_cb.label_all_select.setText(_("totality "))
            self.bottom_widget.layout_h_cb.label_2.setText(_(" entries"))
            palette = QPalette()
            palette.setColor(QPalette.Background, QColor(255, 255, 255))
            self.bottom_widget.layout_all_cb.setPalette(palette)
            self.bottom_widget.show_both_title()
            self.show_main_window()
            self.switch_to_list_window()
        elif lw_mode == LWMode.IMPORTANT:
            size_important_human = self.cu.byte_human(self.size_important)
            self.bottom_widget.lw_all_selection.setCurrentRow(0)
            first_item = self.bottom_widget.lw_all_selection.item(0)
            # self.bottom_widget.te_description.setText(first_item.whatsThis())
            first_item.setSelected(False)
            self.bottom_widget.setFixedSize(550, 560)
            self.bottom_widget.layout_all_cb.move(0, self.bottom_widget.height() - 70)
            self.bottom_widget.lw_all_selection.show()
            self.bottom_widget.layout_all_cb.label_cancel.hide()
            self.bottom_widget.layout_all_cb.cb.show()
            self.bottom_widget.layout_all_cb.label_3.hide()
            self.bottom_widget.layout_all_cb.label_all_select.show()
            self.bottom_widget.layout_h_cb.cb.show()
            self.bottom_widget.layout_h_cb.label_all_select.setText(_("totality "))
            self.bottom_widget.layout_h_cb.label_2.setText(_(" entries"))
            palette = QPalette()
            palette.setColor(QPalette.Background, QColor(231, 231, 231))
            self.bottom_widget.layout_all_cb.setPalette(palette)
            self.bottom_widget.show_both_title()
            self.show_main_window()
            self.switch_to_list_window()
        elif lw_mode == LWMode.SP:
            # sp包升级时itemlist出现的地方
            self.bottom_widget.sp_selection.setCurrentRow(0)
            first_item = self.bottom_widget.sp_selection.item(0)
            first_item.setSelected(False)
            self.bottom_widget.resize(550, 260)
            self.bottom_widget.sp_selection.show()
            # self.bottom_widget.te_description.setText(first_item.whatsThis())
            self.bottom_widget.show_both_title()
            self.bottom_widget.layout_all_cb.cb.hide()
            self.bottom_widget.layout_h_cb.cb.hide()
            self.bottom_widget.layout_all_cb.label_all_select.hide()
            self.bottom_widget.layout_all_cb.label_3.setText(
                _("Click the Cancel button,") + "\n" + _("system will check if there is any software  needs to update"))
            self.bottom_widget.layout_all_cb.label_3.hide()
            if is_sp_update == False:
                self.bottom_widget.layout_h_cb.label_all_select.setText(
                    _("An upgrade of an Android compatible package has been detected"))
            else:
                self.bottom_widget.layout_h_cb.label_all_select.setText(_("A new SP patch pack has been detected"))
            self.bottom_widget.layout_h_cb.label_num.setText("")
            self.bottom_widget.layout_h_cb.label_2.setText("")
            # self.bottom_widget.layout_all_cb.setAutoFillBackground(True)
            palette = QPalette()
            palette.setColor(QPalette.Background, QColor(255, 255, 255))
            self.bottom_widget.layout_all_cb.setPalette(palette)
            self.is_sp_update = True
            # self.show_main_window()
            self.switch_to_SP_window()

        else:
            size_ordinary_human = self.cu.byte_human(self.size_ordinary)
            self.bottom_widget.lw_all_selection.setCurrentRow(0)
            first_item = self.bottom_widget.lw_all_selection.item(0)
            # self.bottom_widget.te_description.setText(first_item.whatsThis())
            self.bottom_widget.show_both_title()
            self.show_main_window()
            self.switch_to_list_window()

    #
    # 函数：加减计算所选的普通升级包信息
    #
    def recalculate_ordinary_apps_size(self, size_str, flag):
        if flag:
            self.size_ordinary += int(size_str)
            self.selected_num_ordinary += 1
        else:
            self.size_ordinary -= int(size_str)
            self.selected_num_ordinary -= 1

        self.top_widget.label_selected_num.setText(str(self.selected_num_ordinary + self.selected_num_important))
        size_all_human = self.cu.byte_human(self.size_ordinary + self.size_important)
        self.top_widget.label_selected_size.setText(size_all_human)
        size_ordinary_human = self.cu.byte_human(self.size_ordinary)

    #
    # 函数：加减计算所选的重要升级包信息
    #
    def recalculate_important_apps_size(self, size_str, flag):
        if flag:
            self.size_important += int(size_str)
            self.selected_num_important += 1
        else:
            self.size_important -= int(size_str)
            self.selected_num_important -= 1

        size_all_human = self.cu.byte_human(self.size_ordinary + self.size_important)
        size_important_human = self.cu.byte_human(self.size_important)

    #
    # 函数：检查升级区域checkbox的状态
    #
    def set_checkbox(self):
        count = len(self.item_map)
        m = 0
        for item in self.item_map:
            curItem = self.item_map[item]
            if curItem.get_checkbox_status() == True:
                m += 1
        if m == 0:
            self.bottom_widget.layout_h_cb.cb.setCheckState(Qt.Unchecked)
            self.bottom_widget.layout_all_cb.cb.setCheckState(Qt.Unchecked)
        elif m == count:
            self.bottom_widget.layout_h_cb.cb.setCheckState(Qt.Checked)
            self.bottom_widget.layout_all_cb.cb.setCheckState(Qt.Checked)
        else:
            self.bottom_widget.layout_h_cb.cb.setCheckState(Qt.Unchecked)
            self.bottom_widget.layout_all_cb.cb.setCheckState(Qt.Unchecked)

    #
    # 函数：显示到前端
    #
    def show_to_frontend(self):
        if self.isMinimized() == True:
            self.showNormal()

        self.setWindowFlags(Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint | Qt.Widget)
        self.show()
        self.raise_()

    #
    # 函数：重复运行程序
    #
    def single_work(self):
        if self.isHidden() == True:
            if self.launch_mode == LaunchMode.AUTOMATIC:
                self.exit_app()
            print("已经有一个程序在运行了.")
            print(_("A daemon is already running."))
            # self.animation_msg_box.set_animation_args("已经有一个程序在运行了.", False)
            # self.animation_msg_box.set_animation_args(_("A daemon is already running."), False)
            # self.animation_msg_box.showAnimation(5000)
            # self.show_exit_widget(_("A daemon is already running."))
            self.signal_show_exit.emit(_("A daemon is already running."))
        else:
            self.show_to_frontend()

    #
    # 函数：退出界面
    #
    def show_exit_widget(self, string):
        try:
            self.down_load_progress.terminate()
        except:
            pass
        if self.launch_mode == LaunchMode.AUTOMATIC:
            self.exit_app()
        #self.set_default_sourceslist()
        self.update_succuss_widget.setWindowModality(Qt.ApplicationModal)
        self.update_succuss_widget.tip_label.setText(string)
        self.update_succuss_widget.show()
        self.update_succuss_widget.move(self.x() + (self.width() - self.update_succuss_widget.width()) / 2,
                                        self.y() + (self.height() - self.update_succuss_widget.height()) / 2)
        self.exit_time.start(5000)

    #
    # 函数：处理加载时改变加载界面的提示语
    #
    def slot_change_tiplabel(self, string, is_update_kum=False):
        if is_update_kum == False:
            self.loading_widget.tiplabel.setText(string)
        else:
            self.loading_widget.appname_label.show()
            self.loading_widget.label1.show()
            self.loading_widget.tiplabel.setText(string)
            self.loading_widget.appname_label.setText(_("Kylin Update Manager "))
            self.loading_widget.label1.setText(_("have a new version,Updating"))

    #
    # 函数：退出程序
    #
    def exit_app(self, msg=None):
        self.set_default_sourceslist()
        self.exit_time.stop()
        self.kus.at.quit()
        if(self.thread_work):
            self.thread_work.quit()
        if self.iface:
            self.iface.exit_dbus()
        self.close()
        # if self.launch_mode == LaunchMode.AUTOMATIC:
        # os.system("sudo init 0")
        pool.shutdown(False)
        sys.exit(msg)


    #
    # 函数：继续扫描
    #
    def slot_continue_scan(self):

        self.loading_widget.errorlabel.hide()
        self.loading_widget.continue_btn.hide()
        self.loading_widget.cancel_btn.hide()
        self.loading_widget.loadinglabel.show()
        self.loading_widget.tiplabel.show()
        # self.kus.at.quit_thread=True
        self.thread_work.start()

    #
    # 函数：退出程序和dbus后台
    #
    def exit_app_and_dbus(self, msg=None):
        self.set_default_sourceslist()
        self.kus.at.quit()
        pool.shutdown(False)
        if (self.thread_work):
            self.thread_work.quit()
        if self.iface:
            self.iface.exit_dbus()
        self.close()
        # if self.launch_mode == LaunchMode.AUTOMATIC:
        # os.system("sudo init 0")
        sys.exit(msg)

    #
    # 函数：切换到SP包升级界面
    #
    def switch_to_SP_window(self):
        self.show()
        self.loading_widget.show()
        self.sp_timer.start(1)

    #
    # 函数：切换到list界面
    #
    def switch_to_list_window(self):
        if self.launch_mode == LaunchMode.MANUAL:
            # self.loadingAnimation.start()
            self.bottom_widget.sp_selection.hide()
        self.show()
        self.loading_widget.show()
        #self.move_to_center()
        self.timer.start(1)

    #
    # 函数：处理切换到sp升级列表的动画
    #
    def slot_sptimer_timeout(self):
        self.sp_timer.stop()
        loadingwidget_width = self.loading_widget.width()
        loadingwidget_height = self.loading_widget.height()
        loadinglabel_width = self.loading_widget.loadinglabel.width()
        loadinglabel_height = self.loading_widget.loadinglabel.height()
        if loadingwidget_height - 1 > 0 and loadingwidget_width - 2 > 0:
            self.loading_widget.setFixedSize(loadingwidget_width - 2, loadingwidget_height - 1)
            self.loading_widget.move((self.width() - loadingwidget_width - 2) / 2, (
                    self.height() - self.titlebar.height() - loadingwidget_height - 1) / 2 + self.titlebar.height())
            if self.loading_widget.loadinglabel.height() != 0:
                self.loading_widget.loadinglabel.resize(self.loading_widget.loadinglabel.width() - 10,
                                                        self.loading_widget.loadinglabel.height() - 1)
            self.sp_timer.start(4)
        if loadingwidget_width - 2 == 0 or loadingwidget_height - 1 == 0 or loadingwidget_width - 2 < 0 or loadingwidget_height - 1 < 0:
            self.loading_widget.hide()
            self.bottom_widget.show()

    # 用于处理动画中主窗口变大
    #
    def slot_timeout(self):
        self.timer.stop()
        self.bottom_widget.layout_all_cb.move(0, self.height() - 70 - 60)
        # self.bottom_widget.lw_all_selection.hide()
        # self.bottom_widget.hide()
        #self.move_to_center()
        loadingwidget_width = self.loading_widget.width()
        loadingwidget_height = self.loading_widget.height()
        loadinglabel_width = self.loading_widget.loadinglabel.width()
        loadinglabel_height = self.loading_widget.loadinglabel.height()
        x = self.x()
        y = self.y()
        # if self.launch_mode == LaunchMode.MANUAL:
        if self.width() < MAINWIDTH and self.height() + 4 < MAINHEIGHT:
            self.resize(self.width() + 1, self.height() + 4)
            self.titlebar.setFixedSize(self.width(), 40)
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            # self.loading_widget.show()
            if loadingwidget_height - 1 >= 0 and loadingwidget_width - 2 >= 0:
                self.loading_widget.setFixedSize(loadingwidget_width - 2, loadingwidget_height - 1)
                self.loading_widget.move((self.width() - loadingwidget_width - 3) / 2, (
                        self.height() - self.titlebar.height() - loadingwidget_height) / 2 + self.titlebar.height())
                if self.loading_widget.loadinglabel.height() != 0:
                    self.loading_widget.loadinglabel.resize(self.loading_widget.loadinglabel.width() - 10,
                                                            self.loading_widget.loadinglabel.height() - 1)
            self.move(x-1,y-2)
            self.timer.start(10)
        elif self.width() == MAINWIDTH and self.height() + 4 <= MAINHEIGHT:
            self.resize(self.width(), self.height() + 4)
            self.titlebar.setFixedSize(self.width(), 40)
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            self.titlebar.min_button.setGeometry(self.titlebar.width() - 68, 4, 30, 30)
            self.titlebar.set_button.setGeometry(self.titlebar.width() - 102, 4, 30, 30)
            if loadingwidget_height - 2 >= 0 and loadingwidget_width - 4 >= 0:
                self.loading_widget.resize(loadingwidget_width - 6, loadingwidget_height - 3)
                self.loading_widget.move((self.width() - loadingwidget_width - 6) / 2, (
                        self.height() - self.titlebar.height() - loadingwidget_height - 3) / 2 + self.titlebar.height())
                if loadingwidget_width - 6 == 0 or loadingwidget_height - 3 == 0 or loadingwidget_width - 6 < 0 or loadingwidget_height - 3 < 0:
                    self.loading_widget.hide()
                    # self.bottom_widget.show()
            self.titlebar.setGeometry(0, 0, self.width(), 40)
            self.move(x,y-2)
            self.timer.start(10)
        elif self.width() + 1 < MAINWIDTH and self.height() + 3 >= MAINHEIGHT:
            self.resize(self.width() + 1, MAINHEIGHT)
            self.titlebar.setFixedSize(self.width(), 40)
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            self.titlebar.min_button.setGeometry(self.titlebar.width() - 68, 4, 30, 30)
            self.titlebar.set_button.setGeometry(self.titlebar.width() - 102, 4, 30, 30)
            if loadingwidget_height - 2 >= 0 and loadingwidget_width - 4 >= 0:
                self.loading_widget.resize(loadingwidget_width - 6, loadingwidget_height - 3)
                self.loading_widget.move((self.width() - loadingwidget_width - 6) / 2, (
                        self.height() - self.titlebar.height() - loadingwidget_height - 3) / 2 + self.titlebar.height())
                if loadingwidget_width - 6 == 0 or loadingwidget_height - 3 == 0 or loadingwidget_width - 6 < 0 or loadingwidget_height - 3 < 0:
                    self.loading_widget.hide()
                    # self.bottom_widget.show()
            self.titlebar.setGeometry(0, 0, self.width(), 40)
            self.move(x-1,y)
            self.timer.start(10)
        elif self.width() == MAINWIDTH and (self.height() + 3 > MAINHEIGHT or self.height() < MAINHEIGHT):
            self.resize(self.width(), MAINHEIGHT)
            self.titlebar.setFixedSize(self.width(), 40)
            self.loading_widget.hide()
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            self.titlebar.min_button.setGeometry(self.titlebar.width() - 68, 4, 30, 30)
            self.titlebar.min_button.show()
            self.titlebar.set_button.setGeometry(self.titlebar.width() - 102, 4, 30, 30)
            self.titlebar.set_button.show()
            self.bottom_widget.layout_h_cb.show()
            self.bottom_widget.lw_all_selection.show()
            self.bottom_widget.show()
            self.titlebar.setGeometry(0, 0, self.width(), 40)
            self.titlebar.setWindowOpacity(0)
            self.move(x,y)
        elif self.width() == MAINWIDTH and self.height() == MAINHEIGHT:
            self.resize(self.width(), MAINHEIGHT)
            self.titlebar.setFixedSize(self.width(), 40)
            self.loading_widget.hide()
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            self.titlebar.min_button.setGeometry(self.titlebar.width() - 68, 4, 30, 30)
            self.titlebar.min_button.show()
            self.titlebar.set_button.setGeometry(self.titlebar.width() - 102, 4, 30, 30)
            self.titlebar.set_button.show()
            self.bottom_widget.lw_all_selection.show()
            self.bottom_widget.show()
            self.titlebar.setGeometry(0, 0, self.width(), 40)
            self.titlebar.setWindowOpacity(0)
            self.move(x,y)
            # self.timer.start(5)
        # self.mainGroup.start()

    #
    # 函数：切换到详细界面
    #
    def switch_to_detail_window(self):
        self.update_bottom_widget.lw_all_selection.show()
        self.update_bottom_widget.show()
        self.bottom_widget.hide()

    #
    # 函数：窗口居中
    #
    def move_to_center(self):
        windowWidth = QApplication.desktop().screenGeometry(0).width()
        windowHeight = QApplication.desktop().screenGeometry(0).height()
        self.move((windowWidth - self.width()) / 2, (windowHeight - self.height()) / 2)

    #
    # 函数：显示主界面
    #
    def show_main_window(self):
        #self.move_to_center()
        self.show()
        self.raise_()

    #
    # 函数：最小化界面
    #
    def slot_click_min_button(self):
            self.showMinimized()

    #
    # 函数：点击关闭
    #
    def slot_click_close_button(self):

        self.click_cancel_btn = True
        # 正在执行关键更新，点击关闭则hide主界面
        if self.is_working_c == True:
            self.hide()
        else:
            if(self.will_install == True):
                self.click_cancel_btn = False
                # self.animation_msg_box.set_animation_args("更新未完成，请稍等.", False)
                self.animation_msg_box.set_animation_args(_("Updating, Please wait."), False)
                self.animation_msg_box.showAnimation(5000)
            else:
                try:
                    self.down_load_progress.terminate()
                except:
                    pass
                if (len(PKGLIST) == 0):
                    self.pingback("","",_("information acquisition"))
                    self.exit_app()
                else:
                    app_list = []
                    statue_list = []
                    num = 0
                    for pkg in PKGLIST:
                        for i in self.App_Version_list:
                            if i["name"] == pkg:
                                app_list.insert(num, i)
                                statue_list.insert(num, "success")
                                num = num + 1
                                LogManager.INSTALL(("installed " + pkg + ' ' + i['version']))
                    if (len(self.install_fail_list) == 0):
                        self.db_insert_thread.get_variable(app_list, "success", "", statue_list)
                        self.db_insert_thread.start()
                    else:
                        for pkg in self.install_fail_list:
                            for i in self.App_Version_list:
                                if (i["name"] == pkg):
                                    app_list.insert(num, i)
                                    statue_list.insert(num, "Fail")
                        self.db_insert_thread.get_variable(app_list, "success", "", statue_list)
                        self.db_insert_thread.start()


    #
    # 函数：点击更新结束界面的关闭按钮
    #
    def slot_click_tip_close_button(self):
        self.exit_app()

    #
    # 函数：点击设置
    #
    #
    def slot_click_menu_button(self):
        self.get_pos.emit()
        if self.click_config == True:
            self.click_config = False
            self.menu.hide()

        else:
            self.click_config = True
            if(self.menu_init == False):
                self.menu = Menubar(self.width(), self.height(), self.x(), self.y(), self)
                self.menu_init = True
            self.menu.move(338 + self.x(), 34 + self.y())
            self.menu.time.start(0.2)
            self.menu.show()
            self.menu.clicked_btn_statue.connect(self.slot_handle_config_signal)
            self.menu.leave_btn.connect(self.slot_leave_menu_signal)
            self.get_pos.connect(self.get_point)

    # 函数:信号处理函数,点击了设置按钮
    def slot_handle_config_signal(self, re):
        if re == True:
            self.click_config = False

    def slot_leave_menu_signal(self):
        self.click_config = False
        self.menu.hide()

    # 获取鼠标的位置
    def get_point(self):
        x1 = self.titlebar.set_button.x()
        y1 = self.titlebar.set_button.y()
        w1 = self.titlebar.set_button.width()
        h1 = self.titlebar.set_button.height()
        x2 = self.menu.x()
        y2 = self.menu.y()
        w2 = self.menu.width()
        h2 = self.menu.height()
        x = QCursor.pos().x() - self.x()
        y = QCursor.pos().y() - self.y()
        if ((((x1 >= x) or (x1 + w1 <= x)) and ((x2 >= x) or (x2 + w2 <= x))) or (
                ((y1 >= y) or (y >= y1 + h1)) and ((y2 >= y) or (y2 + h2 <= y)))):
            self.menu.hide()
            self.click_config = False

    #
    # 函数：处理down_finish信号
    #
    def slot_down_finish(self, down_done, _percent, appname):
        if appname not in self.crucial_list:
            percent = float(_percent)
            self.down_done = down_done
            self.down_num += 1
            if (self.down_done == True):
                i = 0
                while (i < self.get_app_num):
                    down_item = self.update_bottom_widget.lw_all_selection.item(i)
                    get_item_widget = self.update_bottom_widget.lw_all_selection.itemWidget(down_item)
                    if appname == "kylin-update-manager":
                        pass
                    else:
                        if (get_item_widget.app_msg.NAME == appname):
                            get_item_widget.progress.setValue(int(percent))
                            get_item_widget.sizelabel.setText(str(int(percent)) + "%")
                            break
                    i = i + 1

    #
    # 函数：处理down_start信号
    #
    def slot_down_start(self, _percent, appname):
        if appname not in self.crucial_list:
            percent = float(_percent)
            i = 0
            while (i < self.get_app_num):
                down_item = self.update_bottom_widget.lw_all_selection.item(i)
                get_item_widget = self.update_bottom_widget.lw_all_selection.itemWidget(down_item)
                if appname == "kylin-update-manager":
                    pass
                else:
                    if (get_item_widget.app_msg.NAME == appname):
                        get_item_widget.progress.hide()
                        get_item_widget.progress.setValue(int(percent))
                        get_item_widget.progress.show()
                        get_item_widget.sizelabel.setText(str(int(percent)) + "%")
                        break
                i = i + 1

    #
    # 函数：处理apt_start信号
    #
    def slot_apt_start(self, _percent, appname):
        if appname not in self.crucial_list:
            percent = float(_percent)
            i = 0
            while (i < self.get_app_num):
                install_item = self.update_bottom_widget.lw_all_selection.item(i)
                get_item_widget = self.update_bottom_widget.lw_all_selection.itemWidget(install_item)
                if appname == "kylin-update-manager":
                    pass
                else:
                    if (get_item_widget.app_msg.NAME == appname):
                        get_item_widget.tip_label.move(355, 27)
                        get_item_widget.tip_label.show()
                        get_item_widget.restart_btn.hide()
                        get_item_widget.puase_btn.hide()
                        get_item_widget.cancel_btn.hide()
                        get_item_widget.sizelabel.move(460,27)
                        get_item_widget.sizelabel.hide()
                        get_item_widget.progress_label.hide()
                        if (platform.machine() == 'mips64'):
                            get_item_widget.progress_mips.hide()
                            get_item_widget.progress_mips.setValue(int(percent))
                            get_item_widget.progress_mips.show()
                        else:
                            get_item_widget.install_progress.hide()
                            get_item_widget.install_progress.setValue(int(percent))
                            get_item_widget.install_progress.show()
                        get_item_widget.tip_label.setText(_("installing"))
                        get_item_widget.progress_label.setText(str(int(percent)) + "%")
                        # get_item_widget.label_tips.setText("安装")
                        # get_item_widget.label_tips.setText(_("install"))
                        break
                        # print get_item_widget.app_msg.NAME
                i = i + 1

    #
    # 函数：处理apt_stop信号
    #
    def slot_apt_finish(self, num, appname):
        if(self.Wait_install_list == []):
            self.will_install = False
        if appname not in self.crucial_list:
            self.install_num = num
            self.installed_app_num += 1
            i = 0
            while (i < self.get_app_num):
                install_item = self.update_bottom_widget.lw_all_selection.item(i)
                get_item_widget = self.update_bottom_widget.lw_all_selection.itemWidget(install_item)
                if appname == "kylin-update-manager":
                    pass
                else:
                    if (get_item_widget.app_msg.NAME == appname):
                        get_item_widget.tip_label.move(355, 27)
                        get_item_widget.tip_label.setText(_("Installation successful"))
                        get_item_widget.tip_label.show()
                        get_item_widget.restart_btn.hide()
                        get_item_widget.puase_btn.hide()
                        get_item_widget.cancel_btn.hide()
                        get_item_widget.progress_label.hide()
                        get_item_widget.sizelabel.move(460, 27)
                        get_item_widget.sizelabel.hide()
                        if (platform.machine() == 'mips64'):
                            get_item_widget.progress_mips.hide()
                            get_item_widget.progress_mips.setValue(100)
                            get_item_widget.progress_mips.show()
                        else:
                            get_item_widget.install_progress.hide()
                            get_item_widget.install_progress.setValue(100)
                            get_item_widget.install_progress.show()
                        get_item_widget.progress_label.setText("100%")
                        break
                i = i + 1
            if appname == "kylin-update-desktop" or appname == "kylin-update-server":
                self.kylin_update_install_finish()
            if appname == "kylin-update-manager":
                self.kylin_update_manager_upgrade_finish()

    #
    # 函数：点击安装
    #
    def slot_click_install_button(self):
        self.update_bottom_widget.lw_all_selection.clear()
        self.update_bottom_widget.sp_selection.clear()
        print("start install")
        re = os.popen("uname -m").readline()
        if self.is_sp_update == True:
            i = 0
            print("get_app_num", self.get_app_num)
            while (i < self.get_app_num):
                get_item = self.bottom_widget.sp_selection.item(i)
                get_item_widget = self.bottom_widget.sp_selection.itemWidget(get_item)

                self.work_list.append(get_item_widget.app_msg.NAME)
                self.item_num += 1
                update_item = QListWidgetItem()
                update_list_item = downloadwidget(get_item_widget.app_msg, True, self)
                update_list_item.checkBox.setCheckState(Qt.Checked)
                update_list_item.checkBox.hide()
                update_list_item.checkBox.setEnabled(False)
                update_list_item.logolabel.move(15, 15)
                update_list_item.logolabel.setFixedSize(48, 48)
                update_list_item.appdescribe.setToolTip("")
                update_list_item.splitlabel.hide()
                update_list_item.sizelabel.hide()
                self.update_bottom_widget.layout_h_cb.label_all_select.setText(_("Updating patch pack..."))
                self.update_bottom_widget.layout_h_cb.label_num.setText("")
                self.update_bottom_widget.layout_h_cb.label_2.setText("")
                self.update_bottom_widget.layout_all_cb.cb.hide()
                self.update_bottom_widget.layout_all_cb.label_all_select.hide()
                self.update_bottom_widget.layout_h_cb.cb.hide()
                self.update_bottom_widget.layout_all_cb.setAutoFillBackground(True)
                self.update_bottom_widget.lw_all_selection.addItem(update_item)
                self.update_bottom_widget.lw_all_selection.setItemWidget(update_item, update_list_item)
                palette = QPalette()
                palette.setColor(QPalette.Background, QColor(255, 255, 255))
                self.update_bottom_widget.layout_all_cb.setPalette(palette)
                self.update_bottom_widget.lw_all_selection.show()
                i += 1
            # print("worklist", self.work_list)
        else:
            self.update_bottom_widget.layout_all_cb.cb.setCheckState(self.bottom_widget.layout_all_cb.cb.checkState())  # 获取安装选择界面的cb状态用于设置安装界面的
            self.update_bottom_widget.layout_h_cb.cb.setCheckState(self.bottom_widget.layout_h_cb.cb.checkState())
            self.bottom_widget.lw_all_selection.show()
            self.update_bottom_widget.resize(550, 560)
            self.update_bottom_widget.lw_all_selection.resize(550, 490)
            self.update_bottom_widget.lw_all_selection.show()
            self.update_bottom_widget.layout_all_cb.label_cancel.hide()
            self.update_bottom_widget.layout_all_cb.move(0, self.update_bottom_widget.height() - 70)
            palette = QPalette()
            palette.setColor(QPalette.Background, QColor(231, 231, 231))
            self.update_bottom_widget.layout_all_cb.setPalette(palette)
            i = 0
            print("get_app_num", self.get_app_num)
            while (i < self.get_app_num):
                get_item = self.bottom_widget.lw_all_selection.item(i)
                get_item_widget = self.bottom_widget.lw_all_selection.itemWidget(get_item)
                if get_item_widget.get_checkbox_status():
                    self.work_list.append(get_item_widget.app_msg.NAME)
                    self.item_num += 1
                    update_item = QListWidgetItem()
                    update_list_item = downloadwidget(get_item_widget.app_msg, True, self)
                    update_list_item.checkBox.setCheckState(Qt.Checked)
                    update_list_item.appdescribe.setToolTip("")
                    update_list_item.sizelabel.hide()
                    update_list_item.checkBox.setEnabled(False)
                    self.update_bottom_widget.lw_all_selection.addItem(update_item)
                    self.update_bottom_widget.lw_all_selection.setItemWidget(update_item, update_list_item)
                else:
                    update_item = QListWidgetItem()
                    update_list_item = downloadwidget(get_item_widget.app_msg, False, self)
                    update_list_item.appdescribe.setToolTip("")
                    update_list_item.progress.hide()
                    update_list_item.install_progress.hide()
                    update_list_item.checkBox.setCheckState(Qt.Unchecked)
                    update_list_item.checkBox.setEnabled(False)
                    self.update_bottom_widget.lw_all_selection.addItem(update_item)
                    self.update_bottom_widget.lw_all_selection.setItemWidget(update_item, update_list_item)
                i += 1
            print("pre:worklist", self.work_list)
            self.update_bottom_widget.layout_h_cb.label_all_select.setText(_("There are"))
            self.update_bottom_widget.layout_h_cb.label_num.setText(str(self.item_num))
            self.update_bottom_widget.layout_h_cb.label_2.setText(_("packages are being updated"))
        if self.work_list:
            self.is_working = True
            self.switch_to_detail_window()
            app = self.work_list.pop(0)
            self.thread1 = pool.submit(self.down_deb_pkg,app)
            print("li:install finished")
        else:
            # self.animation_msg_box.set_animation_args("至少选择一个更新.", False)
            #self.animation_msg_box.set_animation_args(_("Select one entry at least."), False)
            #self.animation_msg_box.showAnimation(5000)
            self.tipwidget.move(self.x() + (self.width() - self.tipwidget.width()) / 2,
                                  self.y() + (self.height() - self.tipwidget.height()) / 2)
            self.tipwidget.tip_label.setText(_("Select one entry at least"))
            self.tipwidget.tip_quit_label.hide()
            self.tipwidget.show()

    #
    #函数：关闭至少选择一项更新界面
    #
    def tipwidget_hide(self):
        self.tipwidget.hide()


    #
    #函数：获取下载连接
    #
    def get_download_url(self,url_list,pkg,appname):
        down_appname = ""
        down_appname1 = ""
        down_appname2 = ""
        downfile_path = ""
        url = ""
        upkg = UPackage(pkg)
        print("获取下载链接")
        print(url_list)
        for i in url_list:
            cmd = "apt-cache show %s | grep 'Filename'" % (upkg.name)
            lines = os.popen(cmd).readlines()
            print(lines)
            for line in lines:
                if "Filename" in line:
                    path = line.split(":",1)[1]
                    downfile_path = path.strip()
                    getname = downfile_path
                    get_list = getname.split("/")
                    num = len(get_list)-1
                    down_appname = get_list[num]
                    print(down_appname)
                    break
            if(downfile_path != ""):
                if('%' in down_appname):
                    print(down_appname.split("_")[1])
                    values = {}
                    values['down_appname_version'] = down_appname
                    version = urllib.parse.urlencode(values).split("=")[1]
                    print(version)
                    downfile_encode_path = ""
                    for n in downfile_path.split('/'):
                        if(n != down_appname):
                            downfile_encode_path = downfile_encode_path+"/"
                            downfile_encode_path = downfile_encode_path + n
                        else:
                            downfile_encode_path = downfile_encode_path +"/"+version
                    url = i + downfile_encode_path
                else:
                    url = i + "/" + downfile_path
                print(url)
                try:
                    req = urllib.request.urlopen(url,timeout=1)
                    file_down_load_size = int(req.headers['Content-Length'])
                    down_url = url
                    return file_down_load_size, down_url, down_appname
                except:
                    if (upkg.name not in self.install_fail_list):
                        self.install_fail_list.append(upkg.name)
                    return file_down_load_size, "", down_appname
                    pass


        '''if upkg.name == "kylin-update-desktop" or upkg.name == "kylin-update-server":
            architecture = pkg.architecture()
            down_appname1 = appname + "_" + upkg.candidateVersion + "_"
            down_appname2 = appname + "_" + upkg.candidateVersion + "_"

        else:
            if appname == upkg.name:
                architecture = pkg.architecture()
                down_appname1 = appname + "_" + upkg.candidateVersion+ "_"
                down_appname2 = appname + "_" + upkg.candidateVersion + "_"
        down_appname1 = down_appname1 + architecture + ".deb"
        down_appname2 = down_appname2 + "all.deb"
        url = url + "/pool/" + down_appname1
        url2 = url2 + "/pool/" + down_appname2
        print("url = " + url)
        print("url2 = " + url2)
        try:
            req = urllib.request.urlopen(url)
            file_down_load_size = int(req.headers['Content-Length'])
            down_url = url
            down_appname = down_appname1
            return file_down_load_size,down_url,down_appname
        except:
            try:
                req = urllib.request.urlopen(url2)
                file_down_load_size = int(req.headers['Content-Length'])
                print(file_down_load_size)
                down_url = url2
                down_appname = down_appname2
                return file_down_load_size, down_url, down_appname
            except:
                print("下载依赖包出问题了")
                if(len(self.work_list)!=0):
                    app = self.work_list.pop(0)
                    pool.submit(self.get_dep_pkg,app)
                else:
                    if(len(self.Wait_install_list) == 0 and self.will_install != True):
                        self.signal_show_exit.emit("Download dependency failed")
                    else:
                        pass'''

    #
    #函数：获取依赖包
    #appname_list:软件包名列表（不带版本号）
    #return：依赖包列表、总依赖包大小、是否获取到所有依赖包
    #
    def get_dep_pkg(self,appname_list):
        deppkg_name_list = []
        for appname in appname_list:
            pkg = self.kus.at.ca[appname]
            size = 0
            dep_list = []
            try:
                dep_all_have = True
                print(pkg.candidate.dependencies)
                for dep in pkg.candidate.dependencies:
                    if (dep.installed_target_versions):
                        if (dep.target_versions[0].version == dep.installed_target_versions[0].version):  # 系统已安装该版本依赖包
                            pass
                    elif (dep.target_versions):
                        dep_pkg = self.kus.at.ca[dep.target_versions[0].package.name]
                        if(dep_pkg not in dep_list):
                            dep_list.append(dep_pkg)
                            deppkg_name_list.append(dep.target_versions[0].package.name)
                            size+=dep_pkg.candidate.size
                            self.all_download_size = self.all_download_size + size
                    else:
                        print("下载依赖包出问题了")
                        print(dep)
                        dep_all_have = False
                        print(dep.rawstr)
                        '''if(">" in dep.rawstr):
                            need_down_version = dep.rawstr.split(" ")[0]
                            min_version = ""
                            for i in need_down_version:
                                if i.isdigit() or i ==".":
                                    print(i)
                                    min_version = min_version + i'''
                        return self.all_deppkg_list,self.all_download_size,dep_all_have
                if (len(dep_list) != 0):
                    pass
                else:
                    return  self.all_deppkg_list,self.all_download_size,dep_all_have
                self.all_deppkg_list.extend(dep_list)
                # 递归循环
                self.all_deppkg_list,self.all_dep_size,dep_all_have = self.get_dep_pkg(deppkg_name_list)
                return self.all_deppkg_list, self.all_download_size , dep_all_have
            except:
                return self.all_deppkg_list,size,dep_all_have



    #
    #函数：下载软件包
    #appname:软件包名(不带版本号)
    #
    def down_deb_pkg(self,appname):
        self.all_deppkg_list = []
        self.pkg_download_finish = False
        print("正在下载")
        print(appname)
        url_list = []
        try:
            fp = open(self.kus.SINFO_PATH, "r")
            lines = fp.readlines()
            start = False
            for line in lines:
                if (start == True):
                    if (line.find("[") != -1 or line.strip() == "" or line == None):
                        break
                    else:
                        get_url = (self.kus.available_url + line.strip()).split(" ")
                        url_list.append(get_url[0])
                if (line.find("[sources.list]") != -1):
                    start = True
            fp.close()
        except:
            self.signal_show_exit.emit(_("download failed"))
            return
        if(self.kus.available_url.startswith("file")):
            p = pool.submit(self.iface.call_install_and_upgrade, appname)
        else:
            down_size = 0
            self.all_deppkg_list = []
            self.all_download_size = 0
            for pkg in self.App_Version_list:
                if (pkg["name"] == appname):
                    get_dep_app_list = []
                    get_dep_app_list.append(appname)
                    need_download_app = []
                    download_pkg = self.kus.at.ca[appname]
                    need_download_app.append(download_pkg)
                    dep_list, all_size, dep_all_have = self.get_dep_pkg(get_dep_app_list)
                    self.all_download_size = self.all_download_size + download_pkg.candidate.size
                    app_install_statue = {"name": "", "statue": "", "is_download": "", "is_puase": ""}
                    app_install_statue["name"] = appname
                    app_install_statue["statue"] = False
                    app_install_statue["is_download"] = True
                    app_install_statue["is_puase"] = False
                    app_install_statue["is_restart"] = False
                    num = 0
                    in_list = False
                    for i in self.app_install_statue_list:
                        if i["name"] == appname:
                            self.app_install_statue_list[num]["statue"] = False
                            self.app_install_statue_list[num]["is_download"] = True
                            self.app_install_statue_list[num]["is_puase"] = False
                            in_list = True
                            break
                        num = num + 1
                    if (in_list == False):
                        self.app_install_statue_list.insert(self.install_app_num, app_install_statue)
                        self.install_app_num += 1
                    print("下载时状态列表")
                    print(self.app_install_statue_list)
                    if (dep_all_have == False):
                        if(in_list == True):
                            self.app_install_statue_list[num]["is_download"] = False
                        else:
                            self.app_install_statue_list[self.install_app_num-1]["is_download"] = False
                        print(self.app_install_statue_list)
                        if(appname not in self.install_fail_list):
                            self.install_fail_list.append(appname)
                        if (len(self.work_list) != 0):
                            down = self.work_list.pop(0)
                            pool.submit(self.down_deb_pkg, down)
                            if (len(self.Wait_install_list) != 0 and self.is_working_install ==False):
                                self.installed_deb_finish.emit()
                        else:
                            if (len(self.Wait_install_list) == 0):
                                # self.installed_deb_finish.emit()
                                self.slot_dbus_process_msg("apt", "#install_and_upgrade", "", 100.0, "apt_finish", "")
                        break
                    else:
                        self.all_deppkg_list = dep_list.copy()
                        main_deb = self.kus.at.ca[appname]
                        if(main_deb not in self.all_deppkg_list):
                            self.all_deppkg_list.append(main_deb)
                            dep_list.append(main_deb)
                        print("获取到的所有的依赖包")
                        print(self.all_deppkg_list)
                        for down_pkg in dep_list:
                            file_down_load_size, down_url, down_appname = self.get_download_url(url_list,down_pkg,down_pkg.name)
                            if(down_url == ""):
                                if(len(self.work_list)!=0):
                                    down_pkgname = self.work_list.pop(0)
                                    pool.submit(self.down_deb_pkg, down_pkgname)
                                if(len(self.Wait_install_list)!=0 and self.is_working_install == False):
                                    install_app = self.Wait_install_list.pop(0)
                                    appname_list = install_app.split("_")
                                    p = pool.submit(self.iface.call_install_and_upgrade, appname_list[0])
                                if(len(self.work_list)==0 and len(self.Wait_install_list)==0):
                                    self.slot_dbus_process_msg("apt", "#install_and_upgrade", "", 100.0, "apt_finish", "")
                                return False
                            else:
                                self.downloading_appname = appname
                                down_load_path = os.path.expandvars('$HOME') + "/.cache/kylin-update-manager-deb"
                                log_file = os.path.join(down_load_path, "wget_log")
                                # print(down_load_path)
                                if (os.path.isdir(down_load_path)):
                                    if (os.path.exists(log_file)):
                                        fp = open(log_file, "w")
                                        fp.close()
                                    else:
                                        os.system("touch " + log_file)
                                else:
                                    os.system("mkdir " + down_load_path)
                                    os.system("touch " + log_file)
                                copy_file_name = down_appname
                                cmd = "wget -c -P "+down_load_path+" "+down_url +" -o "+log_file
                                print(cmd)
                                self.is_down_puase = False
                                if(os.path.exists("/var/cache/apt/archives/"+copy_file_name)):
                                    if(in_list == True):
                                        if(self.app_install_statue_list[num]["is_restart"] == False):
                                            print(int(((file_down_load_size+down_size)/self.all_download_size)*100))
                                            self.get_down_progress.emit(str(int(((file_down_load_size+down_size)/self.all_download_size)*100)), appname, copy_file_name)
                                    else:
                                        if (self.app_install_statue_list[self.install_app_num-1]["is_restart"] == False):
                                            print(int(((file_down_load_size + down_size) / self.all_download_size) * 100))
                                            self.get_down_progress.emit(str(int(((file_down_load_size + down_size) / self.all_download_size) * 100)),appname, copy_file_name)
                                    self.slot_down_deb_finish(copy_file_name)
                                    down_size = down_size + file_down_load_size
                                else:
                                    th = pool.submit(self.tail_f,log_file,appname,copy_file_name,file_down_load_size,down_size)
                                    self.down_load_progress = subprocess.Popen(["wget","-c","-P",down_load_path,down_url,"-o",log_file])
                                    down_size =down_size + int(th.result())



    #
    #函数：实现tail -f 的功能
    #log_file:wget结果存放的文件路径
    #downappname:下载的软件名
    #downapp_fullname:软件名加版本号以及架构
    #down_file_size:下载的软件大小
    #all_size:总共要下载的大小
    #down_size:已经下载的大小
    #
    def tail_f(self,log_file,downappname,downapp_fullname,down_file_size,down_size):
        print(down_file_size)
        print(down_size)
        print(self.all_download_size)
        print(downapp_fullname)
        print("tail_f")
        test_log = log_file
        fo = open(test_log, "rb")
        #print("文件名为: ", fo.name)
        fo.seek(0 ,2)
        line = fo.readline()
        while(True):
            if(self.is_down_puase == False and self.click_cancel_btn == False):
                line_str_list = []
                if str(line.decode()).endswith("\n"):
                    line = fo.readline()
                else:
                    line+=fo.readline()
                if("100%" in str(line.decode())) or ("该文件已经被获取了" in str(line.decode())):
                    print(str(int(((down_file_size+down_size)/self.all_download_size)*100)))
                    self.get_down_progress.emit(str(int(((down_file_size+down_size)/self.all_download_size)*100)),downappname,downapp_fullname)
                    self.slot_down_deb_finish(downapp_fullname)
                    break
                line_str = str(line.decode())
                if( '%' in line_str):
                    line_str_list = line_str.strip().split()
                    for i in line_str_list:
                        if('%' in i ):
                            r= re.sub("\D", "", i)
                            if(r=='' or int(r)>100):
                                pass
                            else:
                                send_re = int((((int(r)/100)*down_file_size+down_size)/self.all_download_size)*100)
                                if(send_re <=100):
                                    self.get_down_progress.emit(str(send_re),downappname,downapp_fullname)
            else:
                break
        fo.close()
        return down_file_size


    #
    #函数处理下载结束后拷贝文件
    #appname:软件包名（带版本号）
    #
    def slot_down_deb_finish(self,appname):
        print("拷贝文件")
        print(appname)
        copy_pkg = self.kus.at.ca[appname.split("_")[0]]
        print(copy_pkg.candidate.size)
        if(copy_pkg in self.all_deppkg_list):
            self.all_deppkg_list.remove(copy_pkg)
        num = 0
        for i in self.app_install_statue_list:
            down_finish_name = appname.split("_")[0]
            if(i["name"] == down_finish_name):
                self.app_install_statue_list[num]["is_download"] = False
                break
            num = num+1
        print(self.app_install_statue_list)
        # 所有的依赖包拷贝结束，包括自己
        if (len(self.all_deppkg_list) == 0):
            self.down_deb_finish = True
            if (appname in self.Wait_install_list):
                pass
            else:
                self.Wait_install_list.append(appname)
            if (self.is_working_c == True):
                print("剩余需要下载的软件包")
                print(self.c_work_list)
            else:
                print("剩余需要下载的软件包")
                print(self.work_list)
                print("剩余需要安装的包")
                print(self.Wait_install_list)
        pkg = self.kus.at.ca[down_finish_name]
        values = {}
        values['version'] = pkg.candidate.version
        version = urllib.parse.urlencode(values).split("=")[1]
        dest_debname = ""
        #获取拷贝过去的软件包名
        if('%' in version):
            dest_debname = appname.split("_")[0] +"_"+ version.lower()+"_" +appname.split("_")[2]
        #获取.cache/kylin-update-manager-deb目录下包名
        src_debname = ""
        appname_encode = urllib.parse.unquote(appname)
        if("%" in appname):
            src_debname = appname_encode
        else:
            src_debname = appname
        cmd = os.path.join(os.environ['HOME'] + "/.cache/kylin-update-manager-deb", src_debname)
        print(cmd)
        print(dest_debname)
        if(dest_debname ==""):
            if(os.path.exists("/var/cache/apt/archives/"+appname)):
                self.slot_copy_deb_finish(appname)
            else:
                self.iface.call_copy_deb(cmd,down_finish_name,dest_debname)
        else:
            if (os.path.exists("/var/cache/apt/archives/" + dest_debname)):
                self.slot_copy_deb_finish(appname)
            else:
                self.iface.call_copy_deb(cmd, down_finish_name, dest_debname)


    #
    #函数：拷贝结束后安装软件
    #
    def slot_copy_deb_finish(self,appname):
        self.pkg_download_finish = True
        self.copy_one_finish = True
        print("拷贝结束安装软件包")
        if(len(self.all_deppkg_list)==0):
            pool.submit(self.slot_install_debpkg)
            '''if (self.is_working_c == True):
                print("剩余需要下载的软件包")
                print(self.c_work_list)
                if (len(self.c_work_list) == 0):
                    pass
                else:
                    if(self.is_downloading == False):
                        app = self.c_work_list.pop(0)
                        self.thread1 = pool.submit(self.down_deb_pkg, app)
                        self.is_downloading = True
            else:
                print("剩余需要下载的软件包")
                print(self.work_list)
                print("剩余需要安装的包")
                print(self.Wait_install_list)
                if (len(self.work_list) == 0):
                    pass
                else:
                    if(self.is_downloading == False):
                        app = self.work_list.pop(0)
                        self.thread1 = pool.submit(self.down_deb_pkg, app)
                        self.is_downloading = True'''

    #
    #函数：拷贝deb后安装软件包
    #
    def slot_install_debpkg(self):
        print("安装软件包")
        print(self.Wait_install_list)
        print(self.is_working_install)
        if(self.Wait_install_list==[]):
            pass
        else:
            if(self.is_working_install == False):
                self.will_install = True
                install_app = self.Wait_install_list.pop(0)
                print(install_app)
                num = 0
                pkg = self.kus.at.ca[install_app.split("_")[0]]
                values = {}
                values['version'] = pkg.candidate.version
                version = urllib.parse.urlencode(values).split("=")[1]
                dest_debname = ""
                if ('%' in version):
                    dest_debname = install_app.split("_")[0] + "_" + version.lower() + "_" + install_app.split("_")[2]
                else:
                    dest_debname = install_app
                if(os.path.exists("/var/cache/apt/archives/"+dest_debname)):
                    for i in self.app_install_statue_list:
                        appname = dest_debname.split("_")[0]
                        if (i["name"] == appname):
                            self.app_install_statue_list[num]["statue"] = True
                            break
                        num = num + 1
                    print("打印软件包状态列表")
                    print(self.app_install_statue_list)
                    print("\n")

                    appname_list = install_app.split("_")
                    appname = appname_list[0]
                    self.kus.at.ca.close()
                    self.kus.at.ca.open()
                    pkg = self.kus.at.ca[appname]
                    if (pkg.is_installed == True):
                        self.iface.apt_finish.emit(1, appname)
                        self.slot_dbus_process_msg("apt", "#install_and_upgrade", "", 100.0, "apt_finish", "")
                    else:
                        self.is_working_install = True
                        p = pool.submit(self.iface.call_install_and_upgrade, appname)
                    #self.iface.call_install_and_upgrade(appname)
                else:
                    if(install_app in self.Wait_install_list):
                        pass
                    else:
                        self.Wait_install_list.append(install_app)
                        cmd = os.path.join(os.environ['HOME']+"/.cache/kylin-update-manager-deb",install_app)
                        #print("copy_src_path = "+cmd)
                        self.iface.call_copy_deb(cmd,install_app.split("_")[0])

    #
    #函数：处理获取进度的信号
    #
    def slot_send_progress(self,ret,appname,app_fullname):
        if appname not in self.crucial_list:
            i = 0
            while (i < self.get_app_num):
                down_item = self.update_bottom_widget.lw_all_selection.item(i)
                get_item_widget = self.update_bottom_widget.lw_all_selection.itemWidget(down_item)
                if appname == "kylin-update-manager":
                    pass
                else:
                    if (get_item_widget.app_msg.NAME == appname):
                        if (platform.machine() == 'mips64'):
                            if(int(ret) <= 100):
                                get_item_widget.progress_mips.hide()
                                get_item_widget.progress_mips.setValue(int(ret))
                                get_item_widget.progress_mips.show()
                                get_item_widget.progress_label.show()
                                get_item_widget.progress_label.setText(str(int(ret)) + "%")
                                if (ret == "100"):
                                    print("下载结束： 下载进度为100%  下载软件包名为" + appname)
                                    self.slot_down_deb_finish(app_fullname)
                                    self.slot_apt_start("0", appname)
                                    get_item_widget.puase_btn.setEnabled(False)
                                    get_item_widget.restart_btn.setEnabled(False)
                        else:
                            if(int(ret) <= 100):
                                get_item_widget.progress.hide()
                                get_item_widget.progress.setValue(int(ret))
                                get_item_widget.progress.show()
                                get_item_widget.progress_label.show()
                                get_item_widget.progress_label.setText(str(int(ret)) + "%")
                                if (ret == "100"):
                                    print("下载结束： 下载进度为100%  下载软件包名为" + appname)
                                    self.slot_down_deb_finish(app_fullname)
                                    self.slot_apt_start("0",appname)
                                    get_item_widget.puase_btn.setEnabled(False)
                                    get_item_widget.restart_btn.setEnabled(False)
                            break
                i = i + 1



    #
    # 函数：点击暂停按钮
    #
    def slot_click_puase_btn(self):
        button = self.sender()
        # 获取按钮相对于listwwdget的坐标
        # listwidget 相对于窗体的坐标 减去 button 相对于窗体的坐标
        # 获取到对象
        buttonpos = button.mapToGlobal(QPoint(0, 0)) - self.update_bottom_widget.lw_all_selection.mapToGlobal(QPoint(0, 0))
        item = self.update_bottom_widget.lw_all_selection.indexAt(buttonpos)
        row = item.row()
        item = self.update_bottom_widget.lw_all_selection.item(row)
        get_widget = self.update_bottom_widget.lw_all_selection.itemWidget(item)
        get_widget.restart_btn.show()
        get_widget.puase_btn.hide()
        app_name = get_widget.applabel.text()
        print(self.app_install_statue_list)
        if(app_name not in self.puase_down_list):
            self.puase_down_list.append(app_name)
        #正在下载第一个
        if (self.app_install_statue_list == []):
            self.puase = True
            if(self.pkg_download_finish == False):
                try:
                    self.down_load_progress.terminate()
                    get_widget.restart_btn.show()
                    get_widget.puase_btn.hide()
                except:
                    self.puase_down_list.remove(app_name)
                    pass
            if(len(self.work_list)!=0):
                appname = self.work_list.pop(0)
                pool.submit(self.down_deb_pkg,appname)
        else:
            in_list = False
            num = 0
            for i in self.app_install_statue_list:
                if (app_name == i["name"]):
                    in_list = True
                    #正在下载可以暂停取消
                    if i['is_download'] == True:
                        print("暂停正在下载的软件包")
                        self.puase = True
                        self.app_install_statue_list[num]["is_puase"] = True
                        if(self.pkg_download_finish == False):
                            print("结束下载进程")
                            try:
                                self.down_load_progress.terminate()
                                get_widget.restart_btn.show()
                                get_widget.puase_btn.hide()
                            except:
                                self.puase_down_list.remove(app_name)
                                pass
                        self.is_down_puase = True
                        if(len(self.work_list)!=0):
                            app = self.work_list.pop(0)
                            pool.submit(self.down_deb_pkg, app)
                            print("下一个下载")
                            print(app)
                        break
                    elif i['is_download'] == False and i["statue"]!=True:#下载结束
                        self.app_install_statue_list[num]["is_puase"] = True
                        print("暂停下载结束的软件包")
                        print(self.Wait_install_list)
                        for j in self.Wait_install_list:
                            name = j.split("_")[0]
                            if(name == i["name"]):
                                print("name = "+name )
                                self.puase =True
                                self.Wait_install_list.remove(j)
                                print(j)
                                print(self.Wait_install_list)
                                break

                num+=1
            if in_list == False:
                print(app_name)
                #不在下载列表，表示还没有下载
                self.work_list.remove(app_name)
            print("暂停了的软件包")
            print(self.puase_down_list)
            print(self.app_install_statue_list)

    #
    #函数：重新下载
    #
    def slot_click_restart_btn(self):
        button = self.sender()
        # 获取按钮相对于listwwdget的坐标
        # listwidget 相对于窗体的坐标 减去 button 相对于窗体的坐标
        # 获取到对象
        buttonpos = button.mapToGlobal(QPoint(0, 0)) - self.update_bottom_widget.lw_all_selection.mapToGlobal(
            QPoint(0, 0))
        item = self.update_bottom_widget.lw_all_selection.indexAt(buttonpos)
        row = item.row()
        item = self.update_bottom_widget.lw_all_selection.item(row)
        get_widget = self.update_bottom_widget.lw_all_selection.itemWidget(item)
        appname = get_widget.applabel.text()
        get_widget.restart_btn.hide()
        get_widget.puase_btn.show()
        get_widget.sizelabel.move(460, 27)
        get_widget.sizelabel.hide()
        print("暂停了吗？")
        print(self.puase_down_list)
        if (len(self.puase_down_list)!=0):
            in_list = False
            num =0
            for i in self.app_install_statue_list:
                if appname == i["name"]:
                    #还没有安装过的包
                    if i["statue"] != True:
                        self.app_install_statue_list[num]["is_puase"] = False
                        self.app_install_statue_list[num]["is_restart"] = True
                        if(len(self.work_list) == 0 ):
                            self.work_list.append(appname)
                            if(self.will_install == False):
                                self.slot_dbus_process_msg("apt" ,"#install_and_upgrade","",100.0,"apt_finish","")
                        else:
                            self.work_list.append(appname)
                        in_list = True
                        self.puase_down_list.remove(appname)
                        '''
                        for i in self.Wait_install_list:
                            wait_appname = i.split("_")
                            if(wait_appname == appname):
                                install_app = self.Wait_install_list.pop(0)
                                pool.submit(self.iface.call_install_and_upgrade,appname)
                                break
                        '''
                        break
                num+=1
            #还没有下载过的包暂停后重新下载
            if(in_list == False):
                self.puase_down_list.remove(appname)
                if (len(self.work_list) == 0):
                    self.work_list.append(appname)
                    if(self.will_install == False):
                        self.slot_dbus_process_msg("apt", "#install_and_upgrade", "", 100.0, "apt_finish", "")
                else:
                    self.work_list.append(appname)

            if(len(self.puase_down_list) == 0):
                self.puase = False

    #
    #函数：取消某个软件的下载
    #
    def slot_click_cancel_btn(self):
        print("取消下载")
        button = self.sender()
        # 获取按钮相对于listwwdget的坐标
        # listwidget 相对于窗体的坐标 减去 button 相对于窗体的坐标
        # 获取到对象
        buttonpos = button.mapToGlobal(QPoint(0, 0)) - self.update_bottom_widget.lw_all_selection.mapToGlobal(QPoint(0, 0))
        item = self.update_bottom_widget.lw_all_selection.indexAt(buttonpos)
        row = item.row()
        item = self.update_bottom_widget.lw_all_selection.item(row)
        get_widget = self.update_bottom_widget.lw_all_selection.itemWidget(item)
        appname = get_widget.applabel.text()
        get_widget.new_versionlabel.show()
        get_widget.appdescribe.show()
        get_widget.progress.hide()
        get_widget.progress_label.hide()
        get_widget.install_progress.show()
        get_widget.restart_btn.hide()
        get_widget.puase_btn.hide()
        get_widget.cancel_btn.hide()
        get_widget.sizelabel.move(460,27)
        get_widget.sizelabel.show()
        get_widget.logolabel.show()
        get_widget.applabel.show()
        #没有安装
        in_list = False
        num = 0
        for i in self.app_install_statue_list:
            if appname == i["name"]:
                in_list = True
                in_wait_list = False
                for j in self.Wait_install_list:
                    wait_appname = j.split("_")[0]
                    if (wait_appname == appname):
                        print("取消：已经下载结束，还未安装")
                        if(i["is_puase"] == True):
                            self.app_install_statue_list[num]["is_puase"] = False
                            self.puase_down_list.remove(i["name"])
                            if (len(self.puase_down_list) == 0):
                                self.puase = False
                        self.Wait_install_list.remove(j)
                        self.iface.call_cancel_download(appname)
                        os.system("rm "+os.path.expandvars('$HOME')+"/.cache/kylin-update-manager-deb/"+appname+"_*")
                    if(appname in self.install_fail_list):
                        print(self.install_fail_list)
                        self.install_fail_list.remove(appname)
                    if(len(self.work_list)==0 and len(self.Wait_install_list)==0 and self.will_install == False):
                        self.slot_dbus_process_msg("apt" ,"#install_and_upgrade","",100.0,"apt_finish","")
                if(in_wait_list == False):
                    print("取消：正在下载")
                    if (i["is_puase"] == True):
                        self.app_install_statue_list[num]["is_puase"] = False
                        print(self.puase_down_list)
                        print(i["name"])
                        self.puase_down_list.remove(i["name"])
                        if(len(self.puase_down_list)==0):
                            self.puase = False
                        #if self.pkg_download_finish == False:
                            #self.down_load_progress.terminate()
                        self.is_down_puase = True
                        homepath = os.path.expandvars('$HOME')
                        print("rm " + homepath + "/.cache/kylin-update-manager-deb/" + appname + "_*")
                    if (appname in self.install_fail_list):
                        self.install_fail_list.remove(appname)
                    if (len(self.work_list) == 0 and len(self.Wait_install_list) == 0 and self.will_install == False):
                        self.slot_dbus_process_msg("apt", "#install_and_upgrade", "", 100.0, "apt_finish", "")
                    #if(i in self.Wait_install_list):
                    '''self.iface.call_cancel_download(appname)
                    os.system("rm " + homepath + "/.cache/kylin-update-manager-deb/" + appname + "_*")
                    self.Wait_install_list.remove(i)'''
            num = num + 1
        if in_list == False:
            if(appname in self.work_list):
                print("还没有下载")
                self.work_list.remove(appname)
                if(appname in self.install_fail_list):
                    self.install_fail_list.remove(appname)
                if (appname in self.puase_down_list):
                    self.puase_down_list.remove(appname)
            else:
                print("正在下载第一个")
                if self.pkg_download_finish == False:
                    try:
                        self.down_load_progress.terminate()
                    except:
                        pass
                self.is_down_puase = True
                homepath = os.path.expandvars('$HOME')
                os.system("rm " + homepath + "/.cache/kylin-update-manager-deb/" + appname + "_*")
                num = 0
                for i in self.app_install_statue_list:
                    if appname == i["name"]:
                        self.app_install_statue_list[num]["is_puase"] = False

                        break
                    num = num+1
                if(appname in self.puase_down_list):
                    self.puase_down_list.remove(appname)
                if (appname in self.install_fail_list):
                    self.install_fail_list.remove(appname)
                if (len(self.work_list) == 0 and len(self.Wait_install_list) == 0 and self.will_install == False):
                    self.slot_dbus_process_msg("apt", "#install_and_upgrade", "", 100.0, "apt_finish", "")



    #
    # 函数：点击取消
    #
    def slot_click_cancel_button(self):
        self.click_cancel = True
        self.get_app_num = 0
        self.work_list = []
        self.is_sp_update = False
        # self.bottom_widget.resize(MAINWIDTH,MAINHEIGHT-60)
        # self.bottom_widget.
        self.bottom_widget.sp_selection.hide()
        # self.kus.start_access()
        self.check_update_thread = Thread_check_update(self)
        self.check_update_thread.start()

    #
    # 函数：点击SP包升级元素
    #
    def slot_click_sp_update_item(self, item):
        get_widget = self.bottom_widget.sp_selection.itemWidget(item)
        self.show_SP_detail_widget(get_widget)

    def slot_click_sp_install_item(self, item):
        get_widget = self.update_bottom_widget.sp_selection.itemWidget(item)
        self.show_SP_detail_widget(get_widget)

    def show_SP_detail_widget(self,get_widget):
        if self.firsttime_click_item == True:
            self.firsttime_click_item = False
            self.app_details = appdetails(get_widget.app_msg, self)
            self.app_details.top_widget.applogolabel.setFixedSize(48, 48)
            self.app_details.top_widget.appnamelabel.move(75, 17)
            self.app_details.top_widget.appversionlabel.move(75, 45)
            self.app_details.move(self.x() + (self.width() - self.app_details.width()) / 2,self.y() + (self.height() - self.app_details.height()) / 2)
            self.app_details.show()
        else:
            self.app_details.top_widget.applogolabel.clear()
            pixmap = QPixmap(get_widget.app_msg.ICON)
            if pixmap.isNull():
                pixmap = QPixmap("./res/soft_logo.png")
            self.app_details.top_widget.applogolabel.setPixmap(pixmap)
            self.app_details.top_widget.appnamelabel.clear()
            self.app_details.top_widget.appnamelabel.setText(get_widget.app_msg.NAME)
            self.app_details.top_widget.appversionlabel.clear()
            self.app_details.top_widget.appversionlabel.setText(_("version:") + get_widget.app_msg.CANDIDATEVERSION)
            self.app_details.descriplabel.clear()
            self.app_details.descriplabel.setText(get_widget.app_msg.DESCRIPTION)
            self.app_details.move(self.x() + (self.width() - self.app_details.width()) / 2,
                                  self.y() + (self.height() - self.app_details.height()) / 2)
            self.app_details.show()

    #
    # 函数：点击软件包升级元素
    #
    def slot_click_update_item(self, item):
        get_widget = self.bottom_widget.lw_all_selection.itemWidget(item)
        self.show_app_detail_widget(get_widget)

    def show_app_detail_widget(self,get_widget):
        if self.firsttime_click_item == True:
            self.firsttime_click_item = False
            self.firsttime_click_item = False
            self.app_details = appdetails(get_widget.app_msg,self)
            self.app_details.move(self.x() + (self.width() - self.app_details.width()) / 2,
                                  self.y() + (self.height() - self.app_details.height()) / 2)
            self.app_details.show()
        else:
            self.app_details.top_widget.applogolabel.clear()
            pixmap = QPixmap(get_widget.app_msg.ICON)
            if pixmap.isNull():
                pixmap = QPixmap("./res/soft_logo.png")
            self.app_details.top_widget.applogolabel.setPixmap(pixmap)
            self.app_details.top_widget.appnamelabel.clear()
            self.app_details.top_widget.appnamelabel.setText(get_widget.app_msg.NAME)
            self.app_details.top_widget.appversionlabel.clear()
            self.app_details.top_widget.appversionlabel.setText(_("version:") + get_widget.app_msg.CANDIDATEVERSION)
            self.app_details.descriplabel.clear()
            self.app_details.descriplabel.setText(get_widget.app_msg.DESCRIPTION)
            self.app_details.move(self.x() + (self.width() - self.app_details.width()) / 2,
                                  self.y() + (self.height() - self.app_details.height()) / 2)
            self.app_details.show()

    #
    # 函数：点击软件包升级元素
    #
    def slot_click_install_item(self, item):
        get_widget = self.update_bottom_widget.lw_all_selection.itemWidget(item)
        self.show_app_detail_widget(get_widget)

    #
    # 函数：重置普通cb状态
    #
    def slot_reset_ordinary_cb(self, status):
        if status == 0:
            for item in self.item_map_ordinary:
                curItem = self.item_map_ordinary[item]
                curItem.checkBox.setCheckState(Qt.Unchecked)
        elif status == 2:
            for item in self.item_map_ordinary:
                curItem = self.item_map_ordinary[item]
                curItem.checkBox.setCheckState(Qt.Checked)

    #
    # 函数：重置cb状态
    #
    def slot_reset_cb(self, status):
        if status == 0:
            for item in self.item_map:
                curItem = self.item_map[item]
                curItem.checkBox.setCheckState(Qt.Unchecked)
        elif status == 2:
            for item in self.item_map:
                curItem = self.item_map[item]
                curItem.checkBox.setCheckState(Qt.Checked)

    #
    # 函数：重置重要cb状态
    #
    def slot_reset_important_cb(self, status):
        if status == 0:
            for item in self.item_map_important:
                curItem = self.item_map_important[item]
                curItem.checkBox.setCheckState(Qt.Unchecked)
        elif status == 2:
            for item in self.item_map_important:
                curItem = self.item_map_important[item]
                curItem.checkBox.setCheckState(Qt.Checked)

    ''' 
    #重绘阴影的函数 
    def paintEvent(self, event):
        m = 9

        path = QPainterPath()
        path.setFillRule(Qt.WindingFill)
        path.addRect(m, m, self.width() - m * 2, self.height() - m * 2)

        painter = QPainter(self)
        # painter.drawLine(QLineF)
        # painter.setRenderHint(QPainter.Antialiasing, True)
        painter.fillPath(path, QBrush(Qt.white))

        color = QColor(100, 100, 100, 30)
        # for(int i=0; i<10; i++)

        for i in range(m):
            path = QPainterPath()
            path.setFillRule(Qt.WindingFill)
            path.addRoundedRect(m - i, m - i, self.width() - (m - i) * 2, self.height() - (m - i) * 2, 1, 1)
            color.setAlpha(90 - math.sqrt(i) * 30)
            painter.setPen(QPen(color, 1, Qt.SolidLine))
            painter.drawRoundedRect(QRect(m - i, m - i, self.width() - (m - i) * 2, self.height() - (m - i) * 2), 0, 0)

    #             path = QPainterPath()
    #             path.setFillRule(Qt.WindingFill)
    #             path.addRect(m-i, m-i, self.width()-(m-i)*2, self.height()-(m-i)*2)
    #             color.setAlpha(90 - math.sqrt(i)*30)
    #             painter.setPen(QPen(color,1))
    #             painter.drawPath(path)
    '''


    #
    # 函数：实现无标题栏窗口拖动
    #
    def mousePressEvent(self, event):
        if (event.button() == Qt.LeftButton):
            self.get_pos.emit()
            self.mouse_press = True
            self.drag_pos = event.globalPos() - self.pos()
            event.accept()

    def mouseReleaseEvent(self, event):
        self.mouse_press = False
        self.setWindowOpacity(1)

    def mouseMoveEvent(self, event):
        if (self.mouse_press):
            self.move_pos = event.globalPos()
            self.move(self.move_pos - self.drag_pos)
            self.setWindowOpacity(1)
            event.accept()

pidfile=0
def app_instance():
    global pidfile
    pidfile = open(os.path.realpath(__file__), "r")
    try:
        fcntl.flock(pidfile, fcntl.LOCK_EX | fcntl.LOCK_NB)
    except:
        sys.exit(0)


def main():
    #QCoreApplication.setAttribute(Qt.AA_EnableHighDpiScaling)
    #QCoreApplication.setAttribute(Qt.AA_UseHighDpiPixmaps)
    app = QApplication(sys.argv)
    # QTextCodec.setCodecForTr(QTextCodec.codecForName("UTF-8"))
    # QTextCodec.setCodecForCStrings(QTextCodec.codecForName("UTF-8"))
    globalfont = QFont()
    globalfont.setPixelSize(14)
    globalfont.setFamily("方正黑体_GBK")
    app.setFont(globalfont)

    app.setOrganizationName("Kylin")
    app.setOrganizationDomain("kylinos.cn")
    app.setApplicationName("kylin-update-manager")
    app_instance()

    # 获取启动参数
    if (len(sys.argv) == 1):
        MainWindow(LaunchMode.MANUAL)
        sys.exit(app.exec_())
    elif (len(sys.argv) == 2):
        if (sys.argv[1] == "-m"):
            MainWindow(LaunchMode.MANUAL)
            sys.exit(app.exec_())
        elif (sys.argv[1] == "-auto"):
            MainWindow(LaunchMode.AUTOMATIC)
            sys.exit(app.exec_())
        else:
            # print "参数错误...", sys.argv
            print(_("Parameter Error..."), sys.argv)
    else:
        print(_("Parameter Error..."), sys.argv)


if __name__ == '__main__':
    main()
