#!/usr/bin/python3
# -*- coding: utf-8 -*-

import sys
# reload(sys)
# sys.setdefaultencoding('utf8')
from PyQt5.QtGui import *
from PyQt5.QtCore import *
from PyQt5.QtWidgets import QListWidget, QFrame

from mainui.systembutton import CleanButton
from mainui.button import *

import gettext
gettext.textdomain("kylin-update-manager")

_ = gettext.gettext

class BottomWidget(QWidget):

    m_parent = None
    ordinary_tristate_status = 2
    important_tristate_status = 2
    tristate_status = 2
    ordinary_or_important = False
    click_ordinary_main_cb = pyqtSignal(int)
    click_important_main_cb = pyqtSignal(int)
    click_main_cb = pyqtSignal(int)

    click_item=False

    def __init__(self, is_update=False,parent = None):
        super(BottomWidget,self).__init__(parent)
        self.m_parent = parent
        self.is_update=is_update
        self.setGeometry(0, 60, 550, 260)
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.init_ui()
        self.init_style_sheet()

    #
    # 函数：初始化ui
    #
    def init_ui(self):
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(255,255,255))
        self.setPalette(palette)

        self.layout_h_cb = allselectwidget(self.width(),37,_("totality "),"",_(" entries"),"",self.is_update,False,self)
        self.layout_h_cb.cb.clicked.connect(self.slot_click_cb)
        self.layout_h_cb.setFixedSize(550,37)
        self.layout_h_cb.setGeometry(0,0,550,35)
        self.layout_h_cb.show()

        #self.splitlabel2 = QLabel(self)
        #self.splitlabel2.setStyleSheet("QLabel{background-color:#cfcfcf;border:0px solid #cfcfcf;}")
        #self.splitlabel2.setGeometry(0, 36, self.width(), 1)
        self.sp_selection = QListWidget(self)
        self.sp_selection.setFrameShape(QFrame.NoFrame)
        self.sp_selection.setFocusPolicy(Qt.NoFocus)
        self.sp_selection.setSpacing(0)
        self.sp_selection.setFixedSize(550, 155)
        self.sp_selection.move(0, 36)
        self.sp_selection.hide()


        self.lw_all_selection = QListWidget(self)
        self.lw_all_selection.setFrameShape(QFrame.NoFrame)
        self.lw_all_selection.setFocusPolicy(Qt.NoFocus)
        self.lw_all_selection.setSpacing(0)
        self.lw_all_selection.setFixedSize(550, 455)
        self.lw_all_selection.move(0,36)
        self.lw_all_selection.hide()

        self.splitlabel = QLabel(self)
        self.splitlabel.setStyleSheet("QLabel{background-color:#cfcfcf;border:0px solid #cfcfcf;}")
        self.splitlabel.setGeometry(0,491,self.width(),1)

        self.layout_all_cb =allselectwidget(self.width(),70,_("All selection"),"","","",self.is_update,True,self)
        #self.layout_all_cb.setAttribute(Qt.WA_TranslucentBackground)
        self.layout_all_cb.cb.clicked.connect(self.slot_click_cb)
        self.layout_all_cb.setFixedSize(550,70)
        self.layout_all_cb.setGeometry(0,self.height()-70,550,70)

        self.layout_all_cb.show()


    #
    # 函数：初始化样式
    #
    def init_style_sheet(self):
        self.lw_all_selection.setStyleSheet("QListWidget{background-color:white;border:0px solid #cfcfcf;}QListWidget::item{background-color:white;height:70px;margin-top:0px;border:0px solid #cfcfcf;}QListWidget::item:hover{background:#F4F4F4;}QListWidget::item:selected{background:#F4F4F4;}")
        self.lw_all_selection.verticalScrollBar().setStyleSheet("QScrollBar:vertical{margin:0px 0px 0px 0px;background-color:rgb(255,255,255,100);border:0px;width:6px;}\
                                                                 QScrollBar::sub-line:vertical{subcontrol-origin:margin;border:0px solid red;height:13px}\
                                                                 QScrollBar::up-arrow:vertical{subcontrol-origin:margin;background-color:rgba(0,0,0,0);height:13px}\
                                                                 QScrollBar::sub-page:vertical{background-color:#EEEDF0;}\
                                                                 QScrollBar::handle:vertical{background-color:rgba(0,0,0,20%);width:6px;border-radius:6px;} QScrollBar::handle:vertical:hover{background-color:rgb(0,0,0,10%);opacity:0.1;width:6px;border-radius:6px;}  QScrollBar::handle:vertical:pressed{background-color:rgb(0,0,0,50%);width:6px;border-radius:6px;}\
                                                                 QScrollBar::add-page:vertical{background-color:#EEEDF0;}\
                                                                 QScrollBar::down-arrow:vertical{background-color:rgba(0,0,0,0);}\
                                                                 QScrollBar::add-line:vertical{subcontrol-origin:margin;border:0px solid green;height:13px}")
        self.sp_selection.setStyleSheet("QListWidget{background-color:white;border:0px solid #cfcfcf;}QListWidget::item{background-color:white;height:80px;margin-top:0px;border:0px solid #cfcfcf;}QListWidget::item:hover{background:#F4F4F4;}QListWidget::item:selected{background:#F4F4F4;}")
        self.sp_selection.verticalScrollBar().setStyleSheet("QScrollBar:vertical{margin:0px 0px 0px 0px;background-color:rgb(255,255,255,100);border:0px;width:6px;}\
                                                                 QScrollBar::sub-line:vertical{subcontrol-origin:margin;border:0px solid red;height:13px}\
                                                                 QScrollBar::up-arrow:vertical{subcontrol-origin:margin;background-color:rgba(0,0,0,0);height:13px}\
                                                                 QScrollBar::sub-page:vertical{background-color:#EEEDF0;}\
                                                                 QScrollBar::handle:vertical{background-color:rgba(0,0,0,20%);width:6px;border-radius:6px;} QScrollBar::handle:vertical:hover{background-color:rgb(0,0,0,10%);opacity:0.1;width:6px;border-radius:6px;}  QScrollBar::handle:vertical:pressed{background-color:rgb(0,0,0,50%);width:6px;border-radius:6px;}\
                                                                 QScrollBar::add-page:vertical{background-color:#EEEDF0;}\
                                                                 QScrollBar::down-arrow:vertical{background-color:rgba(0,0,0,0);}\
                                                                 QScrollBar::add-line:vertical{subcontrol-origin:margin;border:0px solid green;height:13px}")

    #
    # 函数：显示多种升级列表
    #
    def show_both_title(self):
        self.layout_h_cb.show()
        #self.label_all_select.show()
        self.layout_all_cb.show()

    #
    # 函数：勾选软件
    #
    def slot_click_cb(self):
        if self.tristate_status == 0:
            self.tristate_status = 2
            self.layout_all_cb.cb.setCheckboxStatus(2)
            self.layout_h_cb.cb.setCheckboxStatus(2)
            self.click_main_cb.emit(2)
        elif self.tristate_status == 1:
            self.tristate_status = 2
            self.layout_all_cb.cb.setCheckboxStatus(0)
            self.layout_h_cb.cb.setCheckboxStatus(0)
            self.click_main_cb.emit(2)
        elif self.tristate_status == 2:
            self.tristate_status = 0
            self.layout_all_cb.cb.setCheckboxStatus(0)
            self.layout_h_cb.cb.setCheckboxStatus(0)
            self.click_main_cb.emit(0)
