from PyQt5.QtGui import *
from PyQt5.QtCore import *
from PyQt5.QtWidgets import QPushButton

from utils.enums import (BUTTON_ENTER, BUTTON_LEAVE, BUTTON_PRESSED, BUTTON_DISABLE)


class breakpoint_continuation_buttom(QPushButton):

    leave_btn = pyqtSignal(int)
    enter_btn = pyqtSignal(int)
    click_btn = pyqtSignal(int)

    def __init__(self,is_puasebtn,is_restartbtn,is_cancelbtn, parent = None):
        super(breakpoint_continuation_buttom,self).__init__(parent)
        #self.setStyleSheet("QPushButton{border-radius:4px;background-color:#3d6be5;}")
        self.is_puasebtn = is_puasebtn
        self.is_restartbtn=is_restartbtn
        self.is_cancelbtn=is_cancelbtn
        self.setFocusPolicy(Qt.NoFocus)
        self.mouse_press = False
        self.status = BUTTON_LEAVE
        self.setFixedSize(15, 15)
        self.move(0,0)
        self.click_btn.connect(self.paintbuttonevent)
        self.enter_btn.connect(self.paintbuttonevent)
        self.leave_btn.connect(self.paintbuttonevent)
        self.leave_btn.emit(0)


    #
    # 函数：鼠标进入事件
    #
    def enterEvent(self,event):
        self.enter_btn.emit(1)
        self.status = BUTTON_ENTER
        self.update()

    #
    # 函数：鼠标按下事件
    #
    def mousePressEvent(self,event):
        if(event.button() == Qt.LeftButton):
            self.mouse_press = True
            self.status = BUTTON_PRESSED
            self.update()

    #
    # 函数：鼠标释放事件
    #
    def mouseReleaseEvent(self,event):
        if(self.mouse_press and self.rect().contains(event.pos())):
            self.mouse_press = False
            self.click_btn.emit(2)
            self.status = BUTTON_ENTER
            self.update()
            self.clicked.emit(True)

    #
    # 函数：鼠标离开事件
    #
    def leaveEvent(self,event):
        self.leave_btn.emit(0)
        self.status = BUTTON_LEAVE
        self.update()

    #
    # 函数：绘图函数
    #
    def paintbuttonevent(self,mouse_statue=0):
        self.painter = QPainter()
        if mouse_statue==0:
            if self.is_puasebtn:
                self.setStyleSheet("QPushButton{background-color:#ffffff;border-radius:6px;image: url(./res/puase3);}")
            elif self.is_restartbtn:
                self.setStyleSheet("QPushButton{background-color:#ffffff;border-radius:6px;image: url(./res/restart3);}")
            else:
                self.setStyleSheet("QPushButton{background-color:#ffffff;border-radius:6px;image: url(./res/cancel3);}")
        elif mouse_statue==1:
            if self.is_puasebtn:
                self.setStyleSheet("QPushButton{background-color:#ffffff;border-radius:6px;image: url(./res/puase2);}")
            elif self.is_restartbtn:
                self.setStyleSheet("QPushButton{background-color:#ffffff;border-radius:6px;image: url(./res/restart2);}")
            else:
                self.setStyleSheet("QPushButton{background-color:#ffffff;border-radius:6px;image: url(./res/cancel2);}")
        elif mouse_statue==2:
            if self.is_puasebtn:
                self.setStyleSheet("QPushButton{background-color:#ffffff;border-radius:6px;image: url(./res/puase1);}")
            elif self.is_restartbtn:
                self.setStyleSheet("QPushButton{background-color:#ffffff;border-radius:6px;image: url(./res/restart1);}")
            else:
                self.setStyleSheet("QPushButton{background-color:#ffffff;border-radius:6px;image: url(./res/cancel1);}")
