#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
from PyQt5.QtGui import *
from PyQt5.QtCore import *
from PyQt5.QtWidgets import QWidget, QCheckBox, QLabel, QProgressBar

from mainui.breakpoint_continuation_buttom import breakpoint_continuation_buttom
import platform

import gettext
gettext.textdomain("kylin-update-manager")

_ = gettext.gettext


class downloadwidget(QWidget):
    app_msg = None
    size_change = pyqtSignal(str, bool)
    MIPS64 = False

    def __init__(self, appmsg,is_clicked=True, parent=None):
        QWidget.__init__(self,parent)
        self.setFixedSize(550, 70)
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.app_msg = appmsg
        self.is_clicked=is_clicked
        self.parent = parent
        self.ui_init()
        self.stylesheet_init()
        self.init_connect()
        if (platform.machine() == 'mips_64'):
            self.MIPS64 = True
        else:
            self.MIPS64 = False

    #
    # 函数：初始化ui
    #
    def ui_init(self):
        self.progress = QProgressBar(self)
        self.progress.setMinimum(0)
        self.progress.setMaximum(100)
        self.progress.setTextVisible(False)
        self.progress.setValue(0)
        self.progress.setFixedSize(550, 70)
        self.progress.move(0, 0)
        self.progress.hide()
        self.progress.setProperty("value", 0)
        self.install_progress = QProgressBar(self)
        self.install_progress.setMinimum(0)
        self.install_progress.setMaximum(100)
        self.install_progress.setTextVisible(False)
        self.install_progress.setValue(0)
        self.install_progress.setFixedSize(550, 70)
        self.install_progress.move(0, 0)
        self.install_progress.setProperty("value", 0)
        self.install_progress.hide()
        self.progress_mips = QProgressBar(self)
        self.progress_mips.setMinimum(0)
        self.progress_mips.setMaximum(100)
        self.progress_mips.setTextVisible(False)
        self.progress_mips.setValue(0)
        self.progress_mips.setFixedSize(380, 10)
        self.progress_mips.setGeometry(90, 50, 380, 10)
        self.progress_mips.hide()
        self.checkBox = QCheckBox(self)
        self.checkBox.move(15, 27)
        self.logolabel = QLabel(self)
        self.logolabel.setFixedSize(32, 32)
        self.logolabel.setGeometry(44, 19, 32, 32)
        self.tip_label = QLabel(self)
        self.tip_label.setFixedWidth(80)
        self.tip_label.move(355, 20)
        self.tip_label.hide()
        self.applabel = QLabel(self)
        self.applabel.setFixedWidth(240)
        self.applabel.move(90, 17)
        #self.applabel.setGeometry(94, 17, 240, 20)
        self.appdescribe = QLabel(self)
        self.appdescribe.setFixedWidth(240)
        self.appdescribe.move(90, 45)
        #self.appdescribe.setGeometry(90, 40, 240, 18)
        #self.progress.setVisible(False)
        self.new_versionlabel = QLabel(self)
        self.new_versionlabel.setFixedWidth(110)
        self.new_versionlabel.move(355,27)
        #self.new_versionlabel.setGeometry(359, 27, 110, 16)
        self.sizelabel = QLabel(self)
        self.sizelabel.setFixedWidth(80)
        self.sizelabel.move(460, 27)
        self.progress_label = QLabel(self)
        self.progress_label.setFixedWidth(50)
        self.progress_label.move(355,27)
        self.progress_label.setText("0.0%")
        self.progress_label.hide()
        #self.sizelabel.setGeometry(485, 27, 50, 16)
        self.splitlabel = QLabel(self)
        self.splitlabel.setFixedSize(self.width(), 1)
        self.splitlabel.setGeometry(0, 69, self.width(), 1)
        self.restart_btn = breakpoint_continuation_buttom(False,True,False,self)
        self.restart_btn.move(497,27)
        self.restart_btn.hide()
        self.puase_btn = breakpoint_continuation_buttom(True, False, False, self)
        self.puase_btn.move(497, 27)
        self.puase_btn.hide()
        self.cancel_btn = breakpoint_continuation_buttom( False, False, True, self)
        self.cancel_btn.move(520, 27)
        self.cancel_btn.hide()
        if self.is_clicked==True:
            self.new_versionlabel.hide()
            self.appdescribe.hide()
            self.sizelabel.move(15,65)
            self.sizelabel.show()
            #self.progress.show()
            #self.tip_label.move(300,20)
            #self.tip_label.show()
            self.progress_label.move(355, 27)
            #self.progress_label.show()
            self.puase_btn.show()
            self.cancel_btn.show()
            self.logolabel.show()
            self.applabel.show()
        else:
            self.new_versionlabel.show()
            self.appdescribe.show()
            self.progress.hide()
            self.sizelabel.show()
            self.logolabel.show()
            self.applabel.show()

    #
    # 函数：初始化样式
    #
    def stylesheet_init(self):
        self.checkBox.setFocusPolicy(Qt.NoFocus)
        self.checkBox.setCheckState(Qt.Checked)
        self.checkBox.setStyleSheet("QCheckBox{border-radius:4px;spacing: 0px;color:#666666;font-size:14px;background-color:#FFFFFF;}" \
                                    "QCheckBox:hover{background-color:#DAE3FA;}" \
                                    "QCheckBox::indicator{width: 16px;height: 16px;border-radius:4px;}" \
                                    "QCheckBox::indicator:unchecked{background-color:#FFFFFF;border:1px solid #bfbfbf;}" \
                                    "QCheckBox::indicator:unchecked:hover{background-color:#DAE3FA;border:1px solid #6B8EEB;}" \
                                    "QCheckBox::indicator:unchecked:pressed{background-color:#BCCCF6;border:1px solid #415FC4;}" \
                                    "QCheckBox::indicator{width: 16px;height: 16px;}" \
                                    "QCheckBox::indicator:checked{background-color:#3D6BE5;border:1px solid #415FC4;image: url(./res/check);}" \
                                    "QCheckBox::indicator:checked:hover{background-color:#6B8EEB;border:1px solid #415FC4;image: url(./res/check);}" \
                                    "QCheckBox::indicator:checked:pressed{background-color:#415FC4;border:1px solid #415FC4;image: url(./res/check);}")
        if (self.MIPS64):
            self.progress.setStyleSheet("QProgressBar{border:1px solid #ffffff;background-color: rgba(0,0,0,0%);border-radius: 1px; }" \
                                      "QProgressBar {border: 0px solid grey;border-radius: 0px;text-align: center;}")
            self.install_progress.setStyleSheet("QProgressBar{border:1px solid #ffffff;background-color: rgba(0,0,0,0%);border-radius: 1px; }" \
                                        "QProgressBar {border: 0px solid grey;border-radius: 0px;text-align: center;}")
        else:
            self.progress.setStyleSheet("QProgressBar{border:1px solid #ffffff;background-color: rgba(0,0,0,0%);border-radius: 1px; }"\
                                        "QProgressBar::chunk {background-color: #dae3fa;border-radius:0px;}"\
                                        "QProgressBar {border: 0px solid grey;border-radius: 0px;text-align: center;}")
            self.install_progress.setStyleSheet("QProgressBar{border:1px solid #ffffff;background-color: rgba(0,0,0,0%);border-radius: 1px; }"\
                                        "QProgressBar::chunk {background-color: #bbcbf6;border-radius:0px;}"\
                                        "QProgressBar {border: 0px solid grey;border-radius: 0px;text-align: center;}")
        self.progress_mips.setStyleSheet("QProgressBar{background-color:#ffffff;border:0px solid #aaaaaa;border-radius:0px;color:#666666;text-align:center;}")


        pixmap = QPixmap(self.app_msg.ICON)
        if pixmap.isNull():
            pixmap = QPixmap("./res/soft_logo.png")
        self.logolabel.setPixmap(pixmap)
        # self.applabel.setWordWrap(True)
        self.applabel.setStyleSheet("QLabel{font-size:16px;color:#444444;}")
        # self.applabel.setText(self.appmsg.NAME)
        metrics = QFontMetrics(self.applabel.font())
        elidedText = metrics.elidedText(self.app_msg.NAME, Qt.ElideRight, self.applabel.width())
        if elidedText.endswith("…"):
            self.applabel.setToolTip(self.app_msg.NAME)
            self.applabel.setText(elidedText)
        else:
            self.applabel.setText(elidedText)
        #self.label_tips.setStyleSheet("QLabel{font-size:12px;color:#888888;}")
        self.sizelabel.setStyleSheet("QLabel{font-size:12px;color:#888888;}")
        self.sizelabel.setAlignment(Qt.AlignRight)
        self.progress_label.setStyleSheet("QLabel{font-size:12px;color:#444444;}")
        self.progress_label.setAlignment(Qt.AlignLeft)
        self.sizelabel.setText("0.0%")
        self.tip_label.setStyleSheet("QLabel{font-size:12px;color:#888888;}")
        self.tip_label.setAlignment(Qt.AlignLeft)
        self.tip_label.setText(_("downloading"))
        metrics = QFontMetrics(self.applabel.font())
        elidedText = metrics.elidedText(self.app_msg.NAME, Qt.ElideRight, self.applabel.width())
        if elidedText.endswith("…"):
            self.applabel.setToolTip(self.app_msg.NAME)
            self.applabel.setText(elidedText)
        else:
            self.applabel.setText(elidedText)

        self.judge_elidedText(self.appdescribe, self.app_msg.DESCRIPTION)
        self.appdescribe.setStyleSheet("QLabel{font-size:12px;color:#888888;}")
        self.sizelabel.setStyleSheet("QLabel{font-size:12px;color:#888888;}")
        self.sizelabel.setText(self.app_msg.SIZE)
        self.splitlabel.setStyleSheet("QLabel{background-color:#cfcfcf;border:0px solid #cfcfcf;}")
        self.judge_elidedText(self.new_versionlabel, self.app_msg.CANDIDATEVERSION)
        self.new_versionlabel.setStyleSheet("QLabel{font-size:12px;color:#444444;}")
        self.checkBox.toggled.connect(self.slot_toggle_cb)
        # self.connect(self.checkBox, SIGNAL("toggled(bool)"), self, SLOT("synItemContext()"))


    #
    #函数：初始化信号槽链连接
    #
    def init_connect(self):
        self.cancel_btn.clicked.connect(self.parent.slot_click_cancel_btn)
        self.puase_btn.clicked.connect(self.parent.slot_click_puase_btn)
        self.restart_btn.clicked.connect(self.parent.slot_click_restart_btn)

    #
    #函数：用于超过大小用...代替
    #
    def judge_elidedText(self, label, str):
        metrics = QFontMetrics(label.font())
        elidedText = metrics.elidedText(str, Qt.ElideRight, label.width())
        if elidedText.endswith("…"):
            label.setToolTip(str)
            label.setText(elidedText)
        else:
            label.setText(elidedText)

    #
    # 函数：获取cb状态
    #
    def get_checkbox_status(self):
        return self.checkBox.isChecked()

    #
    # 函数：点击cb槽
    #
    def slot_toggle_cb(self):
        if self.checkBox.isChecked():
            self.size_change.emit(self.statusTip(), True)
        else:
            self.size_change.emit(self.statusTip(), False)



