#!/usr/bin/python3
# -*- coding: utf-8 -*-

__author__ = 'lixiang'

from PyQt5.QtGui import *
from PyQt5.QtCore import *
from PyQt5.QtWidgets import QProgressBar

from mainui.titlebar import TitleBar
import platform
from mainui.bottomwidget import *

import gettext
gettext.textdomain("kylin-update-manager")
_ = gettext.gettext


class LoadingWidget(QWidget):

    change_layout = pyqtSignal(str)
    m_parent = None

    def __init__(self, parent = None):
        super(LoadingWidget,self).__init__(parent)
        self.m_parent = parent
        self.setGeometry(0, 0, 550, 280)
        self.setWindowOpacity(0.0)
        #self.widget = QWidget(self)
        #self.widget.setWindowOpacity(1.0)
        #self.widget.setGeometry(0, 0, 400, 160)
        #self.widget.setFixedSize(400,160)
        #self.setWindowFlags(Qt.FramelessWindowHint)
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(255,255,255))#eaf0f3
        self.setPalette(palette)

        if(platform.machine() == 'mips64'):
            self.MIPS64 = True
        else:
            self.MIPS64 = False

        # tleBar(self.width(), False, "麒麟软件更新器", self)
        #self.title_bar = TitleBar(self.width(),False, False, _("Kylin Update Manager"), self)
        #self.title_bar.move(0,0)
        #self.title_bar.show()

        self.init_ui()
        self.init_style_sheet()
        self.init_text()
        self.change_layout.connect(self.m_parent.slot_change_layout)

    #
    # 函数：初始化ui
    #
    def init_ui(self):
        self.tiplabel = QLabel(self)
        self.tiplabel.setGeometry(QRect(0,0,310,17))
        self.tiplabel.setAlignment(Qt.AlignCenter)
        self.errorlabel = QLabel(self)
        self.errorlabel.hide()
        self.update_tip = QLabel(self)
        self.update_tip.hide()
        self.errorlabel.setFixedWidth(300)
        #self.errorlabel.setAlignment(Qt.AlignCenter)
        #self.errorlabel.setGeometry(QRect(50,30,310,20))
        self.progressBar = QProgressBar(self)
        self.progressBar.setGeometry(QRect(10,65,316,19))
        self.progressBar.setValue(0)

        self.appname_label = QLabel(self)
        self.appname_label.hide()
        self.label1 = QLabel(self)
        self.label1.hide()

        self.msglabel = QLabel(self)
        self.msglabel.setText("没有需要更新的程序")
        self.msglabel.setGeometry(0,75,0,0)

        self.loadingmove = QMovie("./res/loading.gif")
        self.loadinglabel = QLabel(self)
        self.loadinglabel.setGeometry(QRect(45,35,310,30))
        self.loadinglabel.setAlignment(Qt.AlignCenter)
        self.loadinglabel.setMovie(self.loadingmove)
        self.loadingmove.start()
        self.loadinglabel.hide()

        self.continue_btn = select_button(_("continue"),False,self)
        self.continue_btn.setFixedSize(100, 40)
        self.continue_btn.hide()

        self.cancel_btn = select_button(_("quit"),False,self)
        self.cancel_btn.setFixedSize(100, 40)
        self.cancel_btn.hide()

        hlayout1=QHBoxLayout()
        hlayout1.addStretch()
        hlayout1.addWidget(self.loadinglabel)
        hlayout1.addWidget(self.update_tip)
        hlayout1.addStretch()

        hlayout2=QHBoxLayout()
        hlayout2.addStretch()
        hlayout2.addWidget(self.tiplabel)
        hlayout2.addWidget(self.appname_label)
        hlayout2.addWidget(self.label1)
        hlayout2.addStretch()

        vlayout=QVBoxLayout()
        vlayout.addStretch()
        vlayout.addLayout(hlayout1)
        vlayout.addSpacing(5)
        vlayout.addLayout(hlayout2)
        vlayout.addStretch()
        #self.vlayout.setContentsMargins(35,0,0,0)
        self.setLayout(vlayout)

    #
    # 函数：初始化样式
    #
    def init_style_sheet(self):
        self.tiplabel.setStyleSheet("QLabel{color:#444444;font-size:14px;}")
        self.appname_label.setStyleSheet("QLabel{color:#f4812c;font-size:14px;}")
        self.label1.setStyleSheet("QLabel{color:#444444;font-size:14px;}")
        self.errorlabel.setStyleSheet("QLabel{color:#3D6BE5;font-size:24px;text-align:center;}")
        self.update_tip.setStyleSheet("QLabel{color:#3D6BE5;font-size:24px;text-align:center;}")
        if(self.MIPS64):
            self.progressBar.setStyleSheet("QProgressBar{background-color:#ffffff;border:1px solid #aaaaaa;border-radius:0px;color:#666666;text-align:center;}")
        else:
            self.progressBar.setStyleSheet("QProgressBar{background-color:#ffffff;border:1px solid #aaaaaa;border-radius:0px;color:#666666;text-align:center;}"
                                          "QProgressBar:chunk{background-color:#7acfff;}")

    #
    # 函数：初始化文字
    #
    def init_text(self):
        #self.tiplabel.setText("正在配置软件管理服务dpkg...")
        self.tiplabel.setText(_("Configuring Software Manager Service dpkg..."))




